
# (c) 2013-2016 Alexander Schoepe, Bochum, DE
# $Id: elatec.tcl,v 2.3 2018/10/05 12:57:50 alex Exp alex $
#
# TWN4 - PRotocol Simple - DocRev6 - September 11, 2014
# TWN4 - PRotocol Simple - DocRev11 - Mai 13, 2016
# TWN4 - PRotocol Simple - DocRev16 - July 7, 2017
#

package require Tcl 8.6

namespace eval ::elatec {
  namespace export \
    RcsId

  variable rcsid
  set rcsid {$Revision: 2.3 $ $Date: 2018/10/05 12:57:50 $}

  variable t4s

  array set t4s {
    TLV_END 0

    EXECUTE_APP 2
    EXECUTE_APP_DEFAULT EXECUTE_APP_AUTO
    EXECUTE_APP_AUTO 0
    EXECUTE_APP_ALWAYS 1

    INDITAG_READMODE 3
    INDITAG_READMODE_DEFAULT INDITAG_READMODE_1
    INDITAG_READMODE_1 1
    INDITAG_READMODE_2 2

    COTAG_READMODE 4
    COTAG_READMODE_DEFAULT COTAG_READMODE_1
    COTAG_READMODE_HASH 0
    COTAG_READMODE_1 1
    COTAG_VERIFY 5
    COTAG_VERIFY_DEFAULT COTAG_VERIFY_ON
    COTAG_VERIFY_OFF OFF
    COTAG_VERIFY_ON ON

    HONEYTAG_READMODE 6
    HONEYTAG_READMODE_DEFAULT HONEYTAG_READMODE_1
    HONEYTAG_READMODE_HASH 0
    HONEYTAG_READMODE_1 1

    ICLASS_READMODE 7
    ICLASS_READMODE_DEFAULT ICLASS_READMODE_UID
    ICLASS_READMODE_UID 0
    ICLASS_READMODE_PAC 1

    API_SYS 0
    API_IO 1
    API_MEM 2
    API_CONV 3
    API_PERIPH 4
    API_RF 5
    API_TILF 6
    API_HITAG1S 7
    API_HITAG2 8
    API_SM4X00 9
    API_I2C 10
    API_MIFARECLASSIC 11
    API_MIFAREULTRALIGHT 12
    API_ISO15693 13
    API_CRYPTO 14
    API_DESFIRE 15
    API_ISO7816 16
    API_ICLASS 17
    API_ISO14443 18
    API_LF 19
    API_HF 20

    USBTYPE_NONE 0
    USBTYPE_CDC 1
    USBTYPE_KEYBOARD 4

    DEVTYPE_LEGICNFC 10
    DEVTYPE_MIFARENFC 11

    WAKEUP_BY_USB_MSK 0x01
    WAKEUP_BY_COM1_MSK 0x02
    WAKEUP_BY_COM2_MSK 0x04

    CHANNEL_NONE 0
    CHANNEL_USB {1 ;# CDC or keyboard}
    CHANNEL_COM1 2
    CHANNEL_COM2 3
    CHANNEL_I2C 4
    CHANNEL_CCID_DATA 0x10
    CHANNEL_CCID_CTRL 0x11
    CHANNEL_SAM1 0x20
    CHANNEL_SAM2 0x21
    CHANNEL_SAM3 0x22
    CHANNEL_SAM4 0x23
    CHANNEL_SC1 0x28
    CHANNEL_RNG 0x30
    CHANNEL_BLUETOOTH 0x40

    DIR_OUT 0
    DIR_IN 1

    COM_WORDLENGTH_8 ((byte)8)
    COM_PARITY_NONE ((byte)0)
    COM_PARITY_ODD ((byte)1)
    COM_PARITY_EVEN ((byte)2)
    COM_STOPBITS_0_5 ((byte)1)
    COM_STOPBITS_1 ((byte)2)
    COM_STOPBITS_1_5 ((byte)3)
    COM_STOPBITS_2 ((byte)4)
    COM_FLOWCONTROL_NONE ((byte)0)

    USB_DEVICE_STATE_DEFAULT 1
    USB_DEVICE_STATE_ADDRESSED 2
    USB_DEVICE_STATE_CONFIGURED 3
    USB_DEVICE_STATE_SUSPENDED 4

    GPIO0 0x01
    GPIO1 0x02
    GPIO2 0x04
    GPIO3 0x08
    GPIO4 0x10
    GPIO5 0x20
    GPIO6 0x40
    GPIO7 0x80

    GPIO_PUPD_NOPULL 0
    GPIO_PUPD_PULLUP 1
    GPIO_PUPD_PULLDOWN 2
    GPIO_OTYPE_PUSHPULL 0
    GPIO_OTYPE_OPENDRAIN 1

    REDLED GPIO0
    GREENLED GPIO1
    YELLOWLED GPIO2

    LEDInit(LEDs) GPIOConfigureOutputs(LEDs,GPIO_PUPD_NOPULL,GPIO_OTYPE_PUSHPULL)
    LEDOn(LEDs) GPIOSetBits(LEDs)
    LEDOff(LEDs) GPIOClearBits(LEDs)
    LEDToggle(LEDs) GPIOToggleBits(LEDs)
    LEDBlink(LEDs,TimeOn,TimeOff) GPIOBlinkBits(LEDs,TimeOn,TimeOff)
    LEDIsOn(LED) GPIOTestBit(LED)

    BEEP_FREQUENCY_HIGH 2400
    BEEP_FREQUENCY_LOW 2057

    SEQ_FUNC(x) {( x << 24)}
    SEQ_CTRL(x) {((x | 0x80) << 24)}
    SEQ_SETBITS SEQ_FUNC(2)
    SEQ_CLEARBITS SEQ_FUNC(3)
    SEQ_TOGGLEBITS SEQ_FUNC(4)
    SEQ_STOP SEQ_CTRL(0)
    SEQ_WAIT SEQ_CTRL(1)
    SEQ_SETCOUNTER SEQ_CTRL(2)
    SEQ_JUMP SEQ_CTRL(3)
    SEQ_DECJMPNZ SEQ_CTRL(4)

    NOTAG 0

    LFTAG_EM4102 {0x40 ;# IDRO_A}
    LFTAG_HITAG1S {0x41 ;# IDRW_B}
    LFTAG_HITAG2 {0x42 ;# IDRW_C}
    LFTAG_EM4150 {0x43 ;# IDRW_D}
    LFTAG_AT5555 {0x44 ;# IDRW_E}
    LFTAG_ISOFDX {0x45 ;# IDRO_G}
    LFTAG_EM4026 {0x46 ;# IDRO_H}
    LFTAG_HITAGU {0x47 ;# IDRW_I}
    LFTAG_EM4305 {0x48 ;# IDRW_K}
    LFTAG_HIDPROX 0x49
    LFTAG_TIRIS 0x4A
    LFTAG_COTAG 0x4B
    LFTAG_IOPROX 0x4C
    LFTAG_INDITAG 0x4D
    LFTAG_HONEYTAG 0x4E
    LFTAG_AWID 0x4F
    LFTAG_GPROX 0x50
    LFTAG_PYRAMID 0x51
    LFTAG_KERI 0x52

    HFTAG_MIFARE 0x80
    HFTAG_ISO14443B 0x81
    HFTAG_ISO15693 0x82
    HFTAG_LEGIC 0x83
    HFTAG_HIDICLASS 0x84
    HFTAG_FELICA 0x85
    HFTAG_SRX 0x86
    HFTAG_NFCP2P 0x87

    TAGMASK(Tagtype) {(1 << (Tagtype & 0x1F))}

    ALL_LFTAGS 0xFFFFFFFF
    ALL_HFTAGS 0xFFFFFFFF

    I2CMODE_MASTER 0x0000
    I2CMODE_SLAVE 0x1000
    I2CMODE_CHANNEL 0x2000
    I2CMODE_ADDRESS_MASK 0x007F

    KEYA 0
    KEYB 1

    ISO15693_TAGTYPE_ICODESL2 0x00
    ISO15693_TAGTYPE_ICODESL2S 0x01
    ISO15693_TAGTYPE_UNKNOWNNXP 0x0F
    ISO15693_TAGTYPE_TAGITHFIPLUSINLAY 0x10
    ISO15693_TAGTYPE_TAGITHFIPLUSCHIP 0x11
    ISO15693_TAGTYPE_TAGITHFISTD 0x12
    ISO15693_TAGTYPE_TAGITHFIPRO 0x13
    ISO15693_TAGTYPE_UNKNOWNTI 0x1F
    ISO15693_TAGTYPE_MB89R118 0x20
    ISO15693_TAGTYPE_MB89R119 0x21
    ISO15693_TAGTYPE_MB89R112 0x22
    ISO15693_TAGTYPE_UNKNOWNFUJI 0x2F
    ISO15693_TAGTYPE_24LR16 0x30
    ISO15693_TAGTYPE_24LR64 0x31
    ISO15693_TAGTYPE_LRI1K 0x40
    ISO15693_TAGTYPE_LRI2K 0x41
    ISO15693_TAGTYPE_LRIS2K 0x42
    ISO15693_TAGTYPE_LRIS64K 0x43
    ISO15693_TAGTYPE_UNKNOWNST 0x4F
    ISO15693_TAGTYPE_SRF55V02P 0x50
    ISO15693_TAGTYPE_SRF55V10P 0x51
    ISO15693_TAGTYPE_SRF55V02S 0x52
    ISO15693_TAGTYPE_SRF55V10S 0x53
    ISO15693_TAGTYPE_UNKNOWNINFINEON 0x5F
    ISO15693_TAGTYPE_UNKNOWN 0xFF

    CRYPTO_ENV0 0
    CRYPTO_ENV1 1
    CRYPTO_ENV2 2
    CRYPTO_ENV3 3
    CRYPTO_ENV_CNT 4

    CRYPTOMODE_AES128 0
    CRYPTOMODE_AES192 1
    CRYPTOMODE_AES256 2
    CRYPTOMODE_3DES 3
    CRYPTOMODE_3K3DES 4
    CRYPTOMODE_CBC_DES 5
    CRYPTOMODE_CBC_DFN_DES 6
    CRYPTOMODE_CBC_3DES 7
    CRYPTOMODE_CBC_DFN_3DES 8
    CRYPTOMODE_CBC_3K3DES 9
    CRYPTOMODE_CBC_AES128 10

    DESF_FILETYPE_STDDATAFILE 0
    DESF_FILETYPE_BACKUPDATAFILE 1
    DESF_FILETYPE_VALUEFILE 2
    DESF_FILETYPE_LINEARRECORDFILE 3
    DESF_FILETYPE_CYCLICRECORDFILE 4
    DESF_COMMSET_PLAIN 0
    DESF_COMMSET_PLAIN_MACED 1
    DESF_COMMSET_FULLY_ENC 3
    DESF_AUTHMODE_COMPATIBLE 0
    DESF_AUTHMODE_EV1 1
    DESF_KEYTYPE_3DES 0
    DESF_KEYTYPE_3K3DES 1
    DESF_KEYTYPE_AES 2
    DESF_KEYLEN_3DES 16
    DESF_KEYLEN_3K3DES 24
    DESF_KEYLEN_AES 16

    ISO7816_PROTOCOL_T0 0
    ISO7816_PROTOCOL_T1 1

    ISO7816_APDU_MAXDATASIZE 256

    ISO7816_ERR_ICC_MUTE 0xFE
    ISO7816_ERR_XFR_PARITY 0xFD
    ISO7816_ERR_HW_ERROR 0xFB
    ISO7816_ERR_BADATRTS 0xF8
    ISO7816_ERR_BADATRTCK 0xF7
    ISO7816_ERR_CMD_SLOT_BUSY 0xE0

    ISO7816_CLOCKSTATUS_RUNNING 0
    ISO7816_CLOCKSTATUS_CLKSTPL 1
    ISO7816_CLOCKSTATUS_CLKSTPH 2
    ISO7816_CLOCKSTATUS_CLKSTPU 3

    ISO7816_POWERSELECT_AUTO 0
    ISO7816_POWERSELECT_5V 1
    ISO7816_POWERSELECT_3V 2
    ISO7816_POWERSELECT_1V8 3

    ISO7816_ICCPRESENTANDACTIVE 0
    ISO7816_ICCPRESENTANDINACTIVE 1
    ISO7816_NOICCPRESENT 2

    ISO7816_FREQUENCY_15000000 7
    ISO7816_FREQUENCY_7500000 6
    ISO7816_FREQUENCY_5000000 5
    ISO7816_FREQUENCY_3750000 4
    ISO7816_FREQUENCY_2500000 3
    ISO7816_FREQUENCY_1875000 2
    ISO7816_FREQUENCY_1250000 1
    ISO7816_FREQUENCY_1000000 0
    ISO7816_FREQUENCY_DEFAULT ISO7816_FREQUENCY_5000000

    LFSEQCMD_END 0
    LFSEQCMD_TUNE 1
    LFSEQCMD_TXBEGIN 2
    LFSEQCMD_TXOFF 3
    LFSEQCMD_TXON 4
    LFSEQCMD_TXKEEPOFF 5
    LFSEQCMD_TXKEEPON 6
    LFSEQCMD_TXSAMPLES 7
    LFSEQCMD_RXBEGIN 8
    LFSEQCMD_RXSKIP 9
    LFSEQCMD_RXSAMPLES 10
  }

  variable spErr

  array set spErr {
    0 ERR_NONE
    1 ERR_UNKNOWN_FUNCTION
    2 ERR_MISSING_PARAMETER
    3 ERR_UNUSED_PARAMETERS
    4 ERR_INVALID_FUNCTION
    5 ERR_PARSER
    6 ERR_LENGTH
  }

  variable spCom

  array set spCom {
    PRS_COMM_MODE_MSK 0x03
    PRS_COMM_MODE_BINARY 0x00
    PRS_COMM_MODE_ASCII 0x01
    PRS_COMM_CRC_MSK 0x0C
    PRS_COMM_CRC_OFF 0x00
    PRS_COMM_CRC_ON 0x04
  }
}

# -----------------------------------------------------------------------------

proc ::elatec::RcsId { {type {}}} {
  variable rcsid

  if {$type != {}} {
    set revision [lindex $rcsid 1]
    if {![string is double -strict $revision]} {
      set revision 0.0
    }
    return $revision
  }
  return $rcsid
}

# -----------------------------------------------------------------------------

proc ::elatec::Log { message { debug 0 } } {
  if {$debug} {
    puts stderr "# [clock format [clock seconds] -format {%Y-%m-%d %H:%M:%S}].[format %03u [expr {[clock clicks -milliseconds] % 1000}]] $message"
  }
}

# -----------------------------------------------------------------------------

proc ::elatec::Hex { data args } {
  set hex [binary encode hex $data]
  set len [string length $hex]
  Log "[string trim \"$args \"] $hex ($len)" 1
}


# -----------------------------------------------------------------------------

proc ::elatec::Check { *value type } {
  variable t4s

  upvar ${*value} value

  switch -- $type {
    CRYPTO_ENV {
      switch -nocase -- $value {
	CRYPTO_ENV0 - ENV0 { set value $t4s(CRYPTO_ENV0) }
	CRYPTO_ENV1 - ENV1 { set value $t4s(CRYPTO_ENV1) }
	CRYPTO_ENV2 - ENV2 { set value $t4s(CRYPTO_ENV2) }
	CRYPTO_ENV3 - ENV3 { set value $t4s(CRYPTO_ENV3) }
      }
      set min 0
      set max $t4s(CRYPTO_ENV_CNT)
      set chk int
    }
    DESF_FILETYPE {
      switch -nocase -- $value {
	DATA -
	STDDAT -
	STANDARD -
	STDDATAFILE -
	FILETYPE_STDDATAFILE -
	DESF_FILETYPE_STDDATAFILE {
	  set value $t4s(DESF_FILETYPE_STDDATAFILE)
	}
	BACKUP -
	BACKUPDATA -
	BACKUPDATAFILE -
	FILETYPE_BACKUPDATAFILE -
	DESF_FILETYPE_BACKUPDATAFILE {
	  set value $t4s(DESF_FILETYPE_BACKUPDATAFILE)
	}
	VALUE -
	VALUEFILE -
	FILETYPE_VALUEFILE -
	DESF_FILETYPE_VALUEFILE {
	  set value $t4s(DESF_FILETYPE_VALUEFILE)
	}
	LINEAR -
	LINEARRECORD -
	LINEARRECORDFILE -
	FILETYPE_LINEARRECORDFILE -
	DESF_FILETYPE_LINEARRECORDFILE {
	  set value $t4s(DESF_FILETYPE_LINEARRECORDFILE)
	}
	CYCLIC -
	CYCLICRECORD -
	CYCLICRECORDFILE -
	FILETYPE_CYCLICRECORDFILE -
	DESF_FILETYPE_CYCLICRECORDFILE {
	  set value $t4s(DESF_FILETYPE_CYCLICRECORDFILE)
	}
      }
      set min 0
      set max 4
      set chk int
    }
    DESF_COMMSET {
      switch -nocase -- $value {
	PLAIN -
	COMMSET_PLAIN -
	DESF_COMMSET_PLAIN {
	  set value $t4s(DESF_COMMSET_PLAIN)
	}
	MACED -
	PLAIN_MACED -
	COMMSET_PLAIN_MACED -
	DESF_COMMSET_PLAIN_MACED {
	  set value $t4s(DESF_COMMSET_PLAIN_MACED)
	}
	ENC -
	FULLY_ENC -
	COMMSET_FULLY_ENC -
	DESF_COMMSET_FULLY_ENC {
	  set value $t4s(DESF_COMMSET_FULLY_ENC)
	}
      }
      set min 0
      set max 3
      set chk int
    }
    DESF_AUTHMODE {
      switch -nocase -- $value {
	COMPATIBLE -
	AUTHMODE_COMPATIBLE -
	DESF_AUTHMODE_COMPATIBLE {
	  set value $t4s(DESF_AUTHMODE_COMPATIBLE)
	}
	EV1 -
	AUTHMODE_EV1 -
	DESF_AUTHMODE_EV1 {
	  set value $t4s(DESF_AUTHMODE_EV1)
	}
      }
      set min 0
      set max 1
      set chk int
    }
    DESF_KEYTYPE {
      switch -nocase -- $value {
	3DES -
	KEYTYPE_3DES -
	DESF_KEYTYPE_3DES {
	  set value $t4s(DESF_KEYTYPE_3DES)
	}
	3K3DES -
	KEYTYPE_3K3DES -
	DESF_KEYTYPE_3K3DES {
	  set value $t4s(DESF_KEYTYPE_3K3DES)
	}
	AES -
	KEYTYPE_AES -
	DESF_KEYTYPE_AES {
	  set value $t4s(DESF_KEYTYPE_AES)
	}
      }
      set min 0
      set max 2
      set chk int
    }
    DESF_KEYLEN {
      if {[lsearch -exact -integer [list $t4s(DESF_KEYLEN_3DES) $t4s(DESF_KEYLEN_3K3DES) $t4s(DESF_KEYLEN_AES)] [string length $value]] == -1} {
        return 0
      } else {
        return 1
      }
    }
    bit -
    1bit -
    bool -
    boolean {
      set min 0
      set max 1
      set chk int
    }
    4bit {
      set min 0
      set max 15
      set chk int
    }
    uchar -
    ubyte -
    uint8 {
      set min 0
      set max 256
      set chk int
    }
    uword -
    uint16 {
      set min 0
      set max 65535
      set chk int
    }
    ulong -
    uint32 {
      set min 0
      set max 4294967295
      set chk int
    }
    uwide -
    uint64 {
      set min 0
      set max 18446744073709551615
      set chk int
    }
    char -
    byte -
    int8 {
      set min -128
      set max 127
      set chk int
    }
    word -
    int16 {
      set min -32768
      set max 32767
      set chk int
    }
    long -
    int32 {
      set min -2147483648
      set max 2147483647
      set chk int
    }
    wide -
    int64 {
      set min -9223372036854775808
      set max 9223372036854775807
      set chk int
    }
    default {
      error {unknown type}
    }
  }
  if {![string is integer -strict $value] || $value < $min || $value > $max} {
    return 0
  }
  return 1
}

proc ::elatec::Adjust { value type } {
  switch -- $type {
    bool -
    boolean {
      set min 0
      set max 1
      set mask 0x1
      set chk uint
    }
    uchar -
    ubyte -
    uint8 {
      set min 0
      set max 256
      set mask 0xFF
      set chk uint
    }
    uword -
    uint16 {
      set min 0
      set max 65535
      set mask 0xFFFF
      set chk uint
    }
    ulong -
    uint32 {
      set min 0
      set max 4294967295
      set mask 0xFFFFFFFF
      set chk uint
    }
    uwide -
    uint64 {
      set min 0
      set max 18446744073709551615
      set mask 0xFFFFFFFFFFFFFFFF
      set chk uint
    }
    default {
      error {unknown type}
    }
  }
  if {![string is integer -strict $value]} {
    return 0
  }
  set value [expr {$value & $mask}]
  if {$min == 0 && $value < 0} {
    return [expr {$value + $max}]
  } 
  return $value
}

proc ::elatec::CheckDESFireKeySettings {*keySettings *changeKeyAccessRights *confChangeable *freeCreateDelete *freeDirList *allowChangeMasterKey} {
  upvar ${*keySettings} keySettings
  upvar ${*changeKeyAccessRights} changeKeyAccessRights
  upvar ${*confChangeable} confChangeable
  upvar ${*freeCreateDelete} freeCreateDelete
  upvar ${*freeDirList} freeDirList
  upvar ${*allowChangeMasterKey} allowChangeMasterKey

  if {![::elatec::Check changeKeyAccessRights 4bit]} {
    return 0
  }
  if {![::elatec::Check confChangeable bit]} {
    return 0
  }
  if {![::elatec::Check freeCreateDelete bit]} {
    return 0
  }
  if {![::elatec::Check freeDirList bit]} {
    return 0
  }
  if {![::elatec::Check allowChangeMasterKey bit]} {
    return 0
  }

  set keySettings [expr {$changeKeyAccessRights << 4}]

  set keySettings [expr {$keySettings | ($confChangeable << 3)}]
  set keySettings [expr {$keySettings | ($freeCreateDelete << 2)}]
  set keySettings [expr {$keySettings | ($freeDirList << 1)}]
  set keySettings [expr {$keySettings | $allowChangeMasterKey}]

  return 1
}

proc ::elatec::DESFireKeySettings { keySettings } {
  set data [dict create]
  if {![string is integer -strict $keySettings]} {
    return $data
  }

  dict set data changeKeyAccessRights [expr {$keySettings & 0xf0}]
  dict set data configurationChangeable [expr {$keySettings & 0x8}]
  dict set data freeCreateDelete [expr {$keySettings & 0x4}]
  dict set data freeDirectoryList [expr {$keySettings & 0x2}]
  dict set data allowChangeMasterKey [expr {$keySettings & 0x1}]

  return $data
}

proc ::elatec::DESFireFileSettings { fileSettings } {
  set data [dict create]
  if {[string length $fileSettings] != 20} {
    return $data
  }
  if {[catch {binary scan $fileSettings cucusua* fileType commSet accessRights void}]} {
    return $data
  }
  switch -- $fileType {
    0 { dict set data type data }
    1 { dict set data type backup }
    2 { dict set data type value }
    3 { dict set data type linear }
    4 { dict set data type cyclic }
  }
  dict set data fileType $fileType
  dict set data commSet $commSet
  # accessRights (14 = free, 15 = never)
  dict set data accessRights read [expr {($accessRights & 0xf000) >> 12}]
  dict set data accessRights write [expr {($accessRights & 0xf00) >> 8}]
  dict set data accessRights read+write [expr {($accessRights & 0xf0) >> 4}]
  dict set data accessRights change [expr {$accessRights & 0xf}]
  switch -- $fileType {
    0 - 1 {
      # DESF_FILETYPE_STDDATAFILE + DESF_FILETYPE_BACKUPDATAFILE
      if {[catch {binary scan $fileSettings iia* void fileSize void }]} {
	return $data
      }
      dict set data fileSize $fileSize
    }
    2 {
      # DESF_FILETYPE_VALUEFILE
      if {[catch {binary scan $fileSettings iiuiuiuca* void lowerLimit upperLimit limitedCreditValue limitedCreditEnabled void}]} {
	return $data
      }
      dict set data lowerLimit $lowerLimit
      dict set data upperLimit $upperLimit
      dict set data limitedCreditValue $limitedCreditValue
      dict set data limitedCreditEnabled $limitedCreditEnabled
    }
    3 - 4 {
      # DESF_FILETYPE_LINEARRECORDFILE + DESF_FILETYPE_CYCLICRECORDFILE
      if {[catch {binary scan $fileSettings iiii void recordSize maxNumberOfRecords currentNumberOfRecords}]} {
	return $data
      }
      dict set data recordSize $recordSize
      dict set data maxNumberOfRecords $maxNumberOfRecords
      dict set data currentNumberOfRecords $currentNumberOfRecords
    }
  }
  return $data
}

# -----------------------------------------------------------------------------

oo::class create ::elatec::sp {
  constructor { device args } {
    my variable obj

    array set obj [list connected false log false device $device baud 9600 binary false crc false api 0.0]

    # com3: ;# Windows
    # /dev/ttyAMA0 ;# Raspberry Pi
    # /dev/cu.usbserial-FTTFRBY8 ;# TTL
    # /dev/cu.usbserial-FTWDHKAP ;# RS232
    # /dev/cu.usbmodem1411       ;# ELATEC TWN4 CDC
    # /dev/cu.usbserial-AM01CGE9 ;# ELATEC MiniReader DevBoard

    set argc [llength $args]
    for {set i 0} {$i < $argc} {incr i} {
      switch -glob -- [lindex $args $i] {
        -asc* {
	  set obj(binary) false
	}
        -bin* {
	  set obj(binary) true
	}
	-nocrc {
	  set obj(crc) false
	}
	-crc {
	  set obj(crc) true
	}
	-speed -
	-baud* {
	  incr i
	  if {[lsearch -exact {75 110 150 300 1200 2400 4800 9600 19200 38400 57600 115200 230400 460800 921600} [lindex $args $i]] > -1} {
	    set obj(baud) [lindex $args $i]
	  }
	}
	-log {
	  set obj(log) true
	}
      }
    }

    if {[set rc [my Open_fd]] != 0} {
      return $rc
    }

    return 0
  }

  method Open_fd {} {
    my variable obj

    ::elatec::Log "Open $obj(connected)" $obj(log)

    if {$obj(connected)} {
      my Close_fd
    }

    if {[string match -nocase {socket://*} $obj(device)]} {
      set obj(type) socket
      set list [split [string range $obj(device) [string last / $obj(device)]+1 end] :]
      set obj(host) [lindex $list 0]
      set obj(port) [lindex $list 1]
      unset list
    } else {
      set obj(type) file
    }

    try {
      if {$obj(type) == {file}} {
	set obj(fd) [open $obj(device) r+]
      } else {
        set obj(fd) [socket $obj(host) $obj(port)]
      }
    } on ok { result options } {
      ::elatec::Log "Open $obj(fd) $obj(device)" $obj(log)
    } on error { result options } {
      set obj(open,error) $result
      return -1010
    }

    if {$obj(binary)} {
      set translation binary
    } else {
      set translation {auto cr}
    }

    try {
      if {$obj(type) == {file}} {
        fconfigure $obj(fd) -translation $translation -buffering none -mode ${obj(baud)},n,8,1 -blocking 0 -handshake none -timeout 5000
      }
      if {$obj(type) == {socket}} {
	fconfigure $obj(fd) -translation $translation -buffering none -blocking 0
      }
    } on ok { result options } {
      ::elatec::Log "Open fconfigure" $obj(log)
    } on error { result options } {
      ::elatec::Log "Open fconfigure: $result"
      set obj(open,error) $result
      my Close_fd
      return -1011
    }

    ::elatec::Log "Open done" $obj(log)
    set obj(connected) true
    set obj(buffer) {}
    set obj(io) {}

    return 0
  }

  method Close_fd {} {
    my variable obj

    ::elatec::Log "Close $obj(connected)" $obj(log)
    if {$obj(connected)} {
      try {
	close $obj(fd)
      } on ok { result options } {
	set obj(connected) false
	::elatec::Log "Close ok $obj(fd)" $obj(log)
	unset -nocomplain obj(fd)
      } on error { result options } {
	::elatec::Log "Close failed" $obj(log)
      }
    }
  }

  destructor {
    my Close_fd
    return 0
  }

  method Crc { data } {
    set crc 65535
    if {[binary scan $data cu* bytes]} {
      foreach byte $bytes {
	set byte [expr {($crc ^ $byte) & 0xff}]
	set byte [expr {(($byte << 4) ^ $byte) & 0xff}]
	set crc [expr {(((($byte << 8) | ($crc >> 8)) ^ ($byte >> 4) ^ ($byte << 3))) & 0xffff}]
      }
    }
    return $crc
  }

  method fe_read { fd } {
    my variable obj

    ### ::elatec::Log fe_read $obj(log)
    if {[eof $obj(fd)]} {
      set [self namespace]::obj(io) EOF
      ::elatec::Log "Read EOF" $obj(log)
      my Close_fd
      after 50
      if {[set rc [my Open_fd]] == 0} {
	fileevent $obj(fd) readable [list [self object] fe_read $obj(fd)]
      }
    } else {
      try {
	if {$obj(binary)} {
	  set data [read $obj(fd)]
	  binary scan $data H* hex
	} else {
	  set data [string tolower [read $obj(fd)]]
	  set hex $data
	}
	::elatec::Log "Read = [string trimright $hex \n]" $obj(log)
      } on ok { result options } {
	set complete 0
	if {$obj(binary)} {
	  append obj(buffer) $data
          if {[set bufferLen [string length $obj(buffer)]] >= 2} {
	    if {![catch {binary scan $obj(buffer) s len} rc]} {
	      if {$bufferLen >= [expr {$len + 2}]} {
		set complete 1
		### fileevent $obj(fd) readable {}
		set obj(buffer) [string range $obj(buffer) 2 end]
	      }
	    }
	  }
	} else {
	  if {[string index $data end] == "\n"} {
	    append obj(buffer) [binary format H* [string range $data 0 end-1]]
	    set complete 1
	    ### fileevent $obj(fd) readable {}
	  } else {
	    append obj(buffer) [binary format H* $data]
	  }
	}
	binary scan $obj(buffer) H* obj(hex,read)
	if {$complete} {
	  set read true
	  if {$obj(crc)} {
	    binary scan [string range $obj(buffer) end-1 end] su crc
	    set obj(buffer) [string range $obj(buffer) 0 end-2]
	    binary scan $obj(buffer) H* obj(hex,read)
	    if {$crc != [my Crc $obj(buffer)]} {
	      set obj(buffer) {}
	      set [self namespace]::obj(io) "ERROR READ CRC"
	      ::elatec::Log "Read ERROR CRC" $obj(log)
	      set read false
	    }
	  }
	  if {$read} {
	    set [self namespace]::obj(io) read
	  }
	}
      } on error { result options } {
	### fileevent $obj(fd) readable {}
	my Close_fd
	set [self namespace]::obj(io) "ERROR READ $result"
	::elatec::Log "Read ERROR $result" $obj(log)
      }
    }
  }

  method Write { data {*data {}} {mode {}} } {
    global tcl_platform
    variable spErr
    my variable obj
    upvar ${*data} returndata

    if {!$obj(connected)} {
      if {[set rc [my Open_fd]] != 0} {
	return -1020
      }
    }
    if {$tcl_platform(os) == {windows}} {
      if {[set err [fconfigure $obj(fd) -lasterror]] == {}} {
      } else {
	set [self namespace]::obj(io) "ERROR LAST $err"
      }
    }
    
    set obj(buffer) {}
    set obj(io) {}

    try {
      fileevent $obj(fd) readable [list [self object] fe_read $obj(fd)]
    } on error { result options } {
      my Close_fd
      return -1021
    }

    #set data [string tolower $data]

    try {
      if {$obj(crc)} {
        set data ${data}[binary format s [my Crc $data]]
      }
      set len [string length $data]
      if {$obj(binary)} {
        set data [binary format s $len]$data
	puts -nonewline $obj(fd) $data
	binary scan $data H* hex
	#flush $obj(fd)
      } else {
	binary scan $data H* hex
	puts $obj(fd) $hex
      }
      ::elatec::Log "Send = [string tolower $hex]" $obj(log)
    } on error { result options } {
      set obj(io) "ERROR WRITE $result"
      my Close_fd
      return -1022
    } on ok { result options } {
      set obj(hex,read) {}
      set obj(hex,send) $hex
    }

    try {
      flush $obj(fd)
    } on error { result options } {
      set obj(io) "ERROR FLUSH $result"
      my Close_fd
      return -1023
    }

    if {$mode == {WriteAndClose}} {
      my Close_fd
      return 0
    }

    set afterId [after 3000 [subst {set [self namespace]::obj(io) TIMEOUT}]]
    vwait [self namespace]::obj(io)
    after cancel $afterId

    if {![info exists obj(buffer)]} {
      set obj(buffer) {}
    }

    binary scan $obj(buffer) H* hex
    if {$obj(io) == {read}} {
      binary scan $obj(buffer) cu obj(response)
      set data [string range $obj(buffer) 1 end]
      unset obj(buffer)

      if {[info exists spErr($obj(response))]} {
        set obj(message) $spErr($obj(response))
      } else {
        set obj(message) unknown
      } 

      catch {set returndata $data}

      return $obj(response)
    }
    return -1024
  }

  method response { {code {}} } {
    variable spErr
    my variable obj

    if {![string is integer -strict $code]} {
      if {![info exists obj(response)]} {
	return {X void}
      }
      set code $obj(response)
    }
    if {[info exists spErr($code)]} {
      return "$code $spErr($code)"
    }
    return {X unknown}
  }

  method info {} {
    my variable obj

    parray obj
  }

  # --- --- --- API SYS --- --- ---

  method reset {} {
    # Command: [0001]
    # Response: [00]

    my Write [binary format H4 0001] {} WriteAndClose
    return 0
  }

  method startBootloader {} {
    # Command: [0002]
    # Response: [00]

    my Write [binary format H4 0002] {} WriteAndClose
    return 0
  }

  method getSysTicks { {*ticks {}} } {
    # Command: [0003]
    # Response: [00][UInt32: Ticks]

    if {[set rc [my Write [binary format H4 0003] rdata]] == 0} {
      if {[string trim ${*ticks}] != {}} {
	upvar ${*ticks} ticks
      }
      if {[catch {binary scan $rdata iu ticks} sc]} {
	return -8
      }
    }
    return $rc
  }

  method getVersionString { {*version {}} {maxLen 50} } {
    # Command: [0004][Byte: MaxLen]
    # Response: [00][ASCII string: Version]

    my variable obj
    if {![::elatec::Check maxLen ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0004 $maxLen] rdata]] == 0} {
      if {[string trim ${*version}] != {}} {
	upvar ${*version} version
      } else {
        set version {}
      }
      if {[catch {binary scan $rdata A* version} sc]} {
        return -8
      }
      if {[string is double -strict $version]} {
	set obj(api) $version
      }
    }
    return $rc
  }

  method getUSBType { {*type {}} } {
    # Command: [0005]
    # Response: [00][Byte: Type]

    if {[set rc [my Write [binary format H4 0005] rdata]] == 0} {
      if {[string trim ${*type}] != {}} {
	upvar ${*type} type
      }
      if {[catch {binary scan $rdata cu type} sc]} {
	return -8
      }
    }
    return $rc
  }

  method getDeviceType { {*type {}} } {
    # Command: [0006]
    # Response: [00][Byte: Type]

    if {[set rc [my Write [binary format H4 0006] rdata]] == 0} {
      if {[string trim ${*type}] != {}} {
	upvar ${*type} type
      }
      if {[catch {binary scan $rdata i cu type} sc]} {
	return -8
      }
    }
    return $rc
  }

  method sleep { ticks flags } {
    # Command: [0007][UInt32: Ticks][UInt32: Flags]
    # Response: [00][Byte: Result]

    if {![::elatec::Check ticks uint32]} {
      return -500
    }
    if {![::elatec::Check flags uint32]} {
      return -501
    }
    set rc [my Write [binary format H4ii 0007 $ticks $flags]]
    return $rc
  }

  method getDeviceUID { {*uid {}} } {
    # Command: [0008]
    # Response: [00][Byte Array(12): UID]

    if {[set rc [my Write [binary format H4 0008] rdata]] == 0} {
      if {[string trim ${*uid}] != {}} {
	upvar ${*uid} uid
	set uid $rdata
      }
    }
    return $rc
  }

  method setParameters { tlv } {
    # Command: [0009][Byte Array(Var): TLV]
    # Response: [00][Bool: Result]

    if {[expr {[set tlvLen [string length $tlv]] % 2}]} {
      return -500
    }
    if {[set rc [my Write [binary format H4cH* 0009 [expr {$tlvLen / 2}] $tlv] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method getLastError { {*lastError {}} } {
    # Command: [000A]
    # Response: [00][UInt32: LastError]

    if {[set rc [my Write [binary format H4 000A] rdata]] == 0} {
      if {[string trim ${*lastError}] != {}} {
	upvar ${*lastError} lastError
      }
      if {[catch {binary scan $rdata iu lastError} sc]} {
        return -8
      }
    }
  }

  # --- --- --- API IO --- --- ---

  method writeByte { channel byte } {
    # Command: [0100][Byte: Channel][Byte: Byte]
    # Response: [00]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check byte ubyte]} {
      return -501
    }
    set rc [my Write [binary format H4cc 0100 $channel $byte]]
    return $rc
  }

  method readByte { channel {*byte {}} } {
    # Command: [0101][Byte: Channel]
    # Response: [00][Byte: Byte]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0101 $channel] rdata]] == 0} {
      if {[string trim ${*byte}] != {}} {
        upvar ${*byte} byte
      }
      if {[catch {binary scan $rdata cu byte} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method testEmpty { channel dir {*result {}} } {
    # Command: [0102][Byte: Channel][Byte: Dir]
    # Response: [00][Bool: Result]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check dir ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0102 $channel $dir] rdata]] == 0} {
      if {[string trim ${*result}] != {}} {
	upvar ${*result} result
      }
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
    }
    return $rc
  }

  method getBufferSize { channel dir {*bufferSize {}} } {
    # Command: [0104][Byte: Channel][Byte: Dir]
    # Response: [00][UInt16: BufferSize]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check dir ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0104 $channel $dir] rdata]] == 0} {
      if {[string trim ${*bufferSize}] != {}} {
        upvar ${*bufferSize} bufferSize
      }
      if {[catch {binary scan $rdata su bufferSize} sc]} {
        return -8
      }
    }
    return $rc
  }

  method getByteCount { channel dir {*byteCount {}} } {
    # Command: [0105][Byte: Channel][Byte: Dir]
    # Response: [00][UInt16: ByteCount]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check dir ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0105 $channel $dir] rdata]] == 0} {
      if {[string trim ${*byteCount}] != {}} {
        upvar ${*byteCount} byteCount
      }
      if {[catch {binary scan $rdata su byteCount} sc]} {
        return -8
      }
    }
    return $rc
  }

  method setCOMParameters { channel baudrate wordLength parity stopBits flowControl } {
    # Command: [0109][Byte: Channel][UInt32: Baudrate][Byte: WordLength][Byte: Parity][Byte: StopBits][Byte: FlowControl]
    # Response: [00][Bool: Result]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check baudrate uint32]} {
      return -501
    }
    if {![::elatec::Check wordLength ubyte]} {
      return -502
    }
    if {![::elatec::Check parity ubyte]} {
      return -503
    }
    if {![::elatec::Check stopBits ubyte]} {
      return -504
    }
    if {![::elatec::Check flowControl ubyte]} {
      return -505
    }
    if {[set rc [my Write [binary format H4cicccc 0109 $channel $baudrate $wordLength $parity $stopBits $flowControl] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method getUSBDeviceState { {*state {}} } {
    # Command: [010A]
    # Response: [00][Byte: State]

    if {[set rc [my Write [binary format H4 010A] rdata]] == 0} {
      if {[string trim ${*state}] != {}} {
        upvar ${*state} state
      }
      if {[catch {binary scan $rdata cu state} sc]} {
        return -8
      }
    }
    return $rc
  }

  method getHostChannel { {*channel {}} } {
    # Command: [010B]
    # Response: [00][Byte: Channel]

    if {[set rc [my Write [binary format H4 010B] rdata]] == 0} {
      if {[string trim ${*channel}] != {}} {
        upvar ${*channel} channel
      }
      if {[catch {binary scan $rdata cu channel} sc]} {
        return -8
      }
    }
    return $rc
  }

  # --- --- --- API PERIPH --- --- ---

  method gpioConfigureOutputs { bits pullUpDown outputType } {
    # Command: [0400][Byte: Bits][Byte: PullUpDown][Byte: OutputType]
    # Response: [00]

    if {![::elatec::Check bits ubyte]} {
      return -500
    }
    if {![::elatec::Check pullUpDown ubyte]} {
      return -501
    }
    if {![::elatec::Check outputType ubyte]} {
      return -502
    }
    set rc [my Write [binary format H4ccc 0400 $bits $pullUpDown $outputType]]
    return $rc
  }

  method gpioConfigureInputs { bits pullUpDown } {
    # Command: [0401][Byte: Bits][Byte: PullUpDown]
    # Response: [00]

    if {![::elatec::Check bits ubyte]} {
      return -500
    }
    if {![::elatec::Check pullUpDown ubyte]} {
      return -501
    }
    set rc [my Write [binary format H4cc 0401 $bits $pullUpDown]]
    return $rc
  }

  method gpioSetBits { bits } {
    # Command: [0402][Byte: Bits]
    # Response: [00]

    if {![::elatec::Check bits ubyte]} {
      return -500
    }
    set rc [my Write [binary format H4c 0402 $bits]]
    return $rc
  }

  method gpioClearBits { bits } {
    # Command: [0403][Byte: Bits]
    # Response: [00]

    if {![::elatec::Check bits ubyte]} {
      return -500
    }
    set rc [my Write [binary format H4c 0403 $bits]]
    return $rc
  }

  method gpioToggleBits { bits } {
    # Command: [0404][Byte: Bits]
    # Response: [00]

    if {![::elatec::Check bits ubyte]} {
      return -500
    }
    set rc [my Write [binary format H4c 0404 %02x $bits]]
    return $rc
  }

  method gpioBlinkBits { bits timeHi timeLo } {
    # Command: [0405][Byte: Bits][UInt16: TimeHi][UInt16: TimeLo]
    # Response: [00]

    if {![::elatec::Check bits ubyte]} {
      return -500
    }
    if {![::elatec::Check timeHi uint16]} {
      return -501
    }
    if {![::elatec::Check timeLo uint16]} {
      return -502
    }
    set rc [my Write [binary format H4css 0405 $bits $timeHi $timeLo]
    return $rc
  }

  method gpioTestBit { bits {*result {}} } {
    # Command: [0406][Byte: Bit]
    # Response: [00][Byte: Result]

    if {![::elatec::Check bits ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0406 $bits] rdata]] == 0} {
      if {[string trim ${*result}] != {}} {
	upvar ${*result} result
      }
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
    }
    return $rc
  }

  method beep { volume frequency onTime offTime } {
    # Command: [0407][Byte: Volume][UInt16: Frequency][UInt16: OnTime][UInt16: OffTime]
    # Response: [00]

    if {![::elatec::Check volume ubyte]} {
      return -500
    }
    if {![::elatec::Check frequency uint16]} {
      return -501
    }
    if {![::elatec::Check onTime uint16]} {
      return -502
    }
    if {![::elatec::Check offTime uint16]} {
      return -503
    }
    set rc [my Write [binary format H4csss 0407 $volume $frequency $onTime $offTime]]
    return $rc
  }

  method diagLedOn {} {
    # Command: [0408]
    # Response: [00]

    set rc [my Write [binary format H4 0408]]
    return $rc
  }

  method diagLedOff {} {
    # Command: [0409]
    # Response: [00]

    set rc [my Write [binary format H4 0409]]
    return $rc
  }

  method diagLedToggle {} {
    # Command: [040A]
    # Response: [00]

    set rc [my Write [binary format H4 040A]]
    return $rc
  }

  method diagLedIsOn { {*result {}} } {
    # Command: [040B]
    # Response: [00][Bool: Result]

    if {[set rc [my Write [binary format H4 040B] rdata]] == 0} {
      if {[string trim ${*result}] != {}} {
	upvar ${*result} result
      }
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
    }
    return $rc
  }

  method sendWiegand { gPIOData0 gPIOData1 pulseTime intervalTime bits bitCount } {
    # Command: [040C][Byte: GPIOData0][Byte: GPIOData1][UInt16: PulseTime][UInt16: IntervalTime][Byte Array(Var): Bits][Byte: BitCount]
    # Response: [00]

    if {![::elatec::Check gPIOData0 ubyte]} {
      return -500
    }
    if {![::elatec::Check gPIOData1 ubyte]} {
      return -501
    }
    if {![::elatec::Check pulseTime uint16]} {
      return -502
    }
    if {![::elatec::Check intervalTime uint16]} {
      return -503
    }
    if {![::elatec::Check bits ubyte]} {
      return -504
    }
    if {![::elatec::Check bitCount ubyte]} {
      return -505
    }
    set rc [my Write [binary format H4ccssca*c 040C $gPIOData0 $gPIOData1 $pulseTime $intervalTime [string length bits] $bits $bitCount]]
    return $rc
  }

  method sendOmron { gPIOData t1 t2 t3 bits bitCount } {
    # Command: [040D][Byte: GPIOClock][Byte: GPIOData][UInt16: T1][UInt16: T2][UInt16: T3][Byte Array(Var): Bits][Byte: BitCount]
    # Response: [00]

    if {![::elatec::Check gPIOClock ubyte]} {
      return -500
    }
    if {![::elatec::Check gPIOData ubyte]} {
      return -501
    }
    if {![::elatec::Check t1 uint16]} {
      return -502
    }
    if {![::elatec::Check t2 uint16]} {
      return -503
    }
    if {![::elatec::Check t3 uint16]} {
      return -504
    }
    if {![::elatec::Check bits ubyte]} {
      return -505
    }
    if {![::elatec::Check bitCount ubyte]} {
      return -506
    }
    set rc [my Write [binary format H4ccsssca*c 040D $gPIOClock $gPIOData $t1 $t2 $t3 [string length bits] $bits $bitCount]]
    return $rc
  }

  # --- --- --- API RF --- --- ---

  method searchTag { {*tagType {}} {*idBitCount {}} {*id {}} {maxIdBytes 16} } {
    # Command: [0500][Byte: MaxIDBytes]
    # Response: [00][Bool: Result][Byte: TagType][Byte: IDBitCount][Byte Array(Var): ID]

    my variable obj
    if {![::elatec::Check maxIdBytes ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0500 $maxIdBytes] rdata]] == 0} {
      if {[string trim ${*tagType}] != {}} {
	upvar ${*tagType} tagType
      }
      if {[string trim ${*idBitCount}] != {}} {
	upvar ${*idBitCount} idBitCount
      }
      if {[string trim ${*id}] != {}} {
	upvar ${*id} id
      }
      if {[catch {binary scan $rdata cucucucua* result tagType idBitCount idLen id} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method setRFOff {} {
    # Command: [0501]
    # Response: [00]

    set rc [my Write [binary format H4 0501]]
    return $rc
  }

  method setTagTypes { tagTypesLF tagTypesHF } {
    # Command: [0502][UInt32: TagTypesLF][UInt32: TagTypesHF]
    # Response: [00]

    if {![::elatec::Check tagTypesLF uint32]} {
      return -500
    }
    if {![::elatec::Check tagTypesHF uint32]} {
      return -501
    }
    set rc [my Write [binary format H4ii 0502 $tagTypesLF $tagTypesHF]]
    return $rc
  }

  method getTagTypes { {*tagTypesLF {}} {*tagTypesHF {}} } {
    # Command: [0503]
    # Response: [00][UInt32: LFTagTypes][UInt32: HFTagTypes]

    if {[set rc [my Write [binary format H4 0503] rdata]] == 0} {
      if {[string trim ${*tagTypesLF}] != {}} {
	upvar ${*tagTypesLF} tagTypesLF
      }
      if {[string trim ${*tagTypesHF}] != {}} {
	upvar ${*tagTypesHF} tagTypesHF
      }
      if {[catch {binary scan $rdata iuiu tagTypesLF tagTypesHF} sc]} {
        return -8
      }
    }
    return $rc
  }

  method getSupportedTagTypes { {*tagTypesLF {}} {*tagTypesHF {}} } {
    # Command: [0504]
    # Response: [00][UInt32: LFTagTypes][UInt32: HFTagTypes]

    if {[set rc [my Write [binary format H4 0504] rdata]] == 0} {
      if {[string trim ${*tagTypesLF}] != {}} {
	upvar ${*tagTypesLF} tagTypesLF
      }
      if {[string trim ${*tagTypesHF}] != {}} {
	upvar ${*tagTypesHF} tagTypesHF
      }
      if {[catch {binary scan $rdata iuiu tagTypesLF tagTypesHF} sc]} {
        return -8
      }
    }
    return $rc
  }

  # --- --- --- API TILF --- --- ---

  method tilf_SearchTag { maxIDBytes {*idBitCount {}} {*id {}} } {
    # Command: [0600][Byte: MaxIDBytes]
    # Response: [00][Bool: Result][Byte: IDBitCount][Byte Array(Var): ID]

    if {![::elatec::Check maxIDBytes ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0600 $maxIDBytes] rdata]] == 0} {
      if {[string trim ${*idBitCount}] != {}} {
        upvar ${*idBitCount} idBitCount
      }
      if {[string trim ${*id}] != {}} {
        upvar ${*id} id
      }
      if {[catch {binary scan $rdata cucucua* result idBitCount @idLen id} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_ChargeOnlyRead { {*data {}} } {
    # Command: [0601]
    # Response: [00][Bool: Result][Byte Array(8): Data]

    if {[set rc [my Write [binary format H4 0601] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_ChargeOnlyReadLo { {*readData {}} } {
    # Command: [0602]
    # Response: [00][Bool: Result][Byte Array(16): ReadData]

    if {[set rc [my Write [binary format H4 0602] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_SPProgramPage { writeData {*readData {}} } {
    # Command: [0603][Byte Array(8): WriteData]
    # Response: [00][Bool: Result][Byte Array(16): ReadData]

    if {![::elatec::Check writeData LENGTH]} {
      return -500
    }
    if {[set rc [my Write [binary format H4a* 0603 $writeData] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_SPProgramPageLo { writeData {*readData {}} } {
    # Command: [0604][Byte Array(10): WriteData]
    # Response: [00][Bool: Result][Byte Array(16): ReadData]

    if {![::elatec::Check writeData LENGTH]} {
      return -500
    }
    if {[set rc [my Write [binary format H4a* 0604 $writeData] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPGeneralReadPage { address {*readData {}} } {
    # Command: [0605][Byte: Address]
    # Response: [00][Bool: Result][Byte Array(8): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0605 $address] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPSelectiveReadPage { address selectiveAddress {*readData {}} } {
    # Command: [0606][Byte: Address][Byte Array(3): SelectiveAddress]
    # Response: [00][Bool: Result][Byte Array(8): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check selectiveAddress LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 0606 $address $selectiveAddress] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPProgramPage { address writeData {*readData {}} } {
    # Command: [0607][Byte: Address][Byte Array(8): WriteData]
    # Response: [00][Bool: Result][Byte Array(8): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check writeData LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 0607 $address $writeData] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPSelectiveProgramPage { address selectiveAddress writeData {*readData {}} } {
    # Command: [0608][Byte: Address][Byte Array(3): SelectiveAddress][Byte Array(8): WriteData]
    # Response: [00][Bool: Result][Byte Array(8): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check selectiveAddress LENGTH]} {
      return -501
    }
    if {![::elatec::Check writeData LENGTH]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ca* 0608 $address $selectiveAddress][binary format a* $writeData] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPLockPage { address {*readData {}} } {
    # Command: [0609][Byte: Address]
    # Response: [00][Bool: Result][Byte Array(8): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0609 $address] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPSelectiveLockPage { address selectiveAddress {*readData {}} } {
    # Command: [060A][Byte: Address][Byte Array(3): SelectiveAddress]
    # Response: [00][Bool: Result][Byte Array(8): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check selectiveAddress LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 060A $address $selectiveAddress] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPGeneralReadPageLo { address {*readData {}} } {
    # Command: [060B][Byte: Address]
    # Response: [00][Bool: Result][Byte Array(16): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 060B $address] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPSelectiveReadPageLo { address selectiveAddress {*readData {}} } {
    # Command: [060C][Byte: Address][Byte Array(3): SelectiveAddress]
    # Response: [00][Bool: Result][Byte Array(16): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check selectiveAddress LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 060C $address $selectiveAddress] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPProgramPageLo { address writeData {*readData {}} } {
    # Command: [060D][Byte: Address][Byte Array(10): WriteData]
    # Response: [00][Bool: Result][Byte Array(16): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check writeData LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 060D $address $writeData] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPSelectiveProgramPageLo { address selectiveAddress writeData {*readData {}} } {
    # Command: [060E][Byte: Address][Byte Array(3): SelectiveAddress][Byte Array(10): WriteData]
    # Response: [00][Bool: Result][Byte Array(16): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check selectiveAddress LENGTH]} {
      return -501
    }
    if {![::elatec::Check writeData LENGTH]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ca* 060E $address $selectiveAddress][binary format a* $writeData] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPLockPageLo { address {*readData {}} } {
    # Command: [060F][Byte: Address]
    # Response: [00][Bool: Result][Byte Array(16): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 060F $address] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MPSelectiveLockPageLo { address selectiveAddress {*readData {}} } {
    # Command: [0610][Byte: Address][Byte Array(3): SelectiveAddress]
    # Response: [00][Bool: Result][Byte Array(16): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check selectiveAddress LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 0610 $address $selectiveAddress] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MUGeneralReadPage { address {*data {}} } {
    # Command: [0611][Byte: Address]
    # Response: [00][Bool: Result][Byte Array(7): Data]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0611 $address] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MUSelectiveReadPage { address selectiveAddress {*data {}} } {
    # Command: [0612][Byte: Address][Byte: SelectiveAddress]
    # Response: [00][Bool: Result][Byte Array(7): Data]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check selectiveAddress ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0612 $address $selectiveAddress] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MUSpecialReadPage { address specialAddress1 specialAddress2 {*data {}} } {
    # Command: [0613][Byte: Address][Byte Array(5): SpecialAddress1][Byte Array(3): SpecialAddress2]
    # Response: [00][Bool: Result][Byte Array(7): Data]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check specialAddress1 LENGTH]} {
      return -501
    }
    if {![::elatec::Check specialAddress2 LENGTH]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ca* 0613 $address $specialAddress1][binary format a* $specialAddress2] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MUProgramPage { address writeData {*readData {}} } {
    # Command: [0614][Byte: Address][Byte Array(5): WriteData]
    # Response: [00][Bool: Result][Byte Array(7): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check writeData LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 0614 $address $writeData] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MUSelectiveProgramPage { address selectiveAddress writeData {*readData {}} } {
    # Command: [0615][Byte: Address][Byte: SelectiveAddress][Byte Array(5): WriteData]
    # Response: [00][Bool: Result][Byte Array(7): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check selectiveAddress ubyte]} {
      return -501
    }
    if {![::elatec::Check writeData LENGTH]} {
      return -502
    }
    if {[set rc [my Write [binary format H4cca* 0615 $address $selectiveAddress $writeData] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MUSpecialProgramPage { address specialAddress1 specialAddress2 writeData {*readData {}} } {
    # Command: [0616][Byte: Address][Byte Array(5): SpecialAddress1][Byte Array(3): Spe- cialAddress2][Byte Array(5): WriteData]
    # Response: [00][Bool: Result][Byte Array(7): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check specialAddress1 LENGTH]} {
      return -501
    }
    if {![::elatec::Check specialAddress2 LENGTH]} {
      return -502
    }
    if {![::elatec::Check writeData LENGTH]} {
      return -503
    }
    if {[set rc [my Write [binary format H4ca* 0616 $address $specialAddress1][binary format a* $specialAddress2][binary format a* $writeData] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MULockPage { address {*readData {}} } {
    # Command: [0617][Byte: Address]
    # Response: [00][Bool: Result][Byte Array(7): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0617 $address] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MUSelectiveLockPage { address selectiveAddress {*readData {}} } {
    # Command: [0618][Byte: Address][Byte: SelectiveAddress]
    # Response: [00][Bool: Result][Byte Array(7): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check selectiveAddress ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0618 $address $selectiveAddress] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method tilf_MUSpecialLockPage { address specialAddress1 specialAddress2 {*readData {}} } {
    # Command: [0619][Byte: Address][Byte Array(5): SpecialAddress1][Byte Array(3): SpecialAddress2]
    # Response: [00][Bool: Result][Byte Array(7): ReadData]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check specialAddress1 LENGTH]} {
      return -501
    }
    if {![::elatec::Check specialAddress2 LENGTH]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ca* 0619 $address $specialAddress1][binary format a* $specialAddress2] rdata]] == 0} {
      if {[string trim ${*readData}] != {}} {
        upvar ${*readData} readData
      }
      if {[catch {binary scan $rdata cua* result readData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API HITAG1S --- --- ---

  method hitag1S_ReadPage { pageAddress {*data {}} } {
    # Command: [0701][Byte: PageAddress]
    # Response: [00][Bool: Result][Byte Array(4): Data]

    if {![::elatec::Check pageAddress ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0701 $pageAddress] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method hitag1S_ReadBlock { blockAddress {*data {}} } {
    # Command: [0702][Byte: BlockAddress]
    # Response: [00][Bool: Result][Byte Array(Var): Data]

    if {![::elatec::Check blockAddress ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0702 $blockAddress] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cucua* result @dataLen data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method hitag1S_WritePage { pageAddress data } {
    # Command: [0703][Byte: PageAddress][Byte Array(4): Data]
    # Response: [00][Bool: Result]

    if {![::elatec::Check pageAddress ubyte]} {
      return -500
    }
    if {![::elatec::Check data LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 0703 $pageAddress $data] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method hitag1S_WriteBlock { blockAddress data {*bytesWritten {}} } {
    # Command: [0704][Byte: BlockAddress][Byte Array(16): Data]
    # Response: [00][Bool: Result][Byte: BytesWritten]

    if {![::elatec::Check blockAddress ubyte]} {
      return -500
    }
    if {![::elatec::Check data LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 0704 $blockAddress $data] rdata]] == 0} {
      if {[string trim ${*bytesWritten}] != {}} {
        upvar ${*bytesWritten} bytesWritten
      }
      if {[catch {binary scan $rdata cucu result bytesWritten} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method hitag1S_Halt {} {
    # Command: [0705]
    # Response: [00][Bool: Result]

    if {[set rc [my Write [binary format H4 0705] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API HITAG2 --- --- ---

  method hitag2_ReadPage { pageAddress {*data {}} } {
    # Command: [0801][Byte: PageAddress]
    # Response: [00][Bool: Result][Byte Array(4): Data]

    if {![::elatec::Check pageAddress ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0801 $pageAddress] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method hitag2_WritePage { pageAddress data } {
    # MISSING METHOD
    # Command: [0802][Byte: PageAddress][Byte Array(4): Data]
    # Response: [00][Bool: Result]

    if {![::elatec::Check pageAddress ubyte]} {
      return -500
    }
    if {![::elatec::Check data LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 0802 $pageAddress $data] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method hitag2_Halt {} {
    # Command: [0803]
    # Response: [00][Bool: Result]

    if {[set rc [my Write [binary format H4 0803] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method hitag2_SetPassword { password } {
    # Command: [0804][Byte Array(4): Password]
    # Response: [00]

    if {![::elatec::Check password LENGTH]} {
      return -500
    }
    set rc [my Write [binary format H4a* 0804 $password]]
    return $rc
  }

  # --- --- --- API SM4X00 --- --- ---

  method sM4X00_GenericRaw { txData maxRXDataLength timeout {*rxData {}} } {
    # Command: [0900][Byte Array(Var): TXData][Byte: MaxRXDataLength][UInt16: Timeout]
    # Response: [00][Bool: Result][Byte Array(Var): RXData]

    if {![::elatec::Check txData ubyte]} {
      return -500
    }
    if {![::elatec::Check maxRXDataLength ubyte]} {
      return -501
    }
    if {![::elatec::Check timeout uint16]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ca*cs 0900 [string length txData] $txData $maxRXDataLength $timeout] rdata]] == 0} {
      if {[string trim ${*rxData}] != {}} {
        upvar ${*rxData} rxData
      }
      if {[catch {binary scan $rdata cucua* result @rxDataLen rxData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method sM4X00_Generic { txData maxRXDataLength timeout {*rxData {}} } {
    # Command: [0901][Byte Array(Var): TXData][Byte: MaxRXDataLength][UInt16: Timeout]
    # Response: [00][Bool: Result][Byte Array(Var): RXData]

    if {![::elatec::Check txData ubyte]} {
      return -500
    }
    if {![::elatec::Check maxRXDataLength ubyte]} {
      return -501
    }
    if {![::elatec::Check timeout uint16]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ca*cs 0901 [string length txData] $txData $maxRXDataLength $timeout] rdata]] == 0} {
      if {[string trim ${*rxData}] != {}} {
        upvar ${*rxData} rxData
      }
      if {[catch {binary scan $rdata cucua* result @rxDataLen rxData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API I2C --- --- ---

  method i2cInit { mode } {
    # Command: [0A00][UInt16: Mode]
    # Response: [00][Bool: Result]
    
    if {![::elatec::Check mode uint16]} {
      return -500
    }
    if {[set rc [my Write [binary format H4s 0A00 $mode] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method i2cDeInit {} {
    # Command: [0A01]
    # Response: [00]

    set rc [my Write [binary format H4 0A01]]
    return $rc
  }

  method i2cMasterStart {} {
    # Command: [0A02]
    # Response: [00]

    set rc [my Write [binary format H4 0A02]]
    return $rc
  }

  method i2cMasterStop {} {
    # Command: [0A03]
    # Response: [00]

    set rc [my Write [binary format H4 0A03]]
    return $rc
  }

  method i2cMasterTransmitByte { data } {
    # Command: [0A04][Byte: Data]
    # Response: [00]

    if {![::elatec::Check data ubyte]} {
      return -500
    }
    set rc [my Write [binary format H4c 0A04 $data]]
    return $rc
  }

  method i2cMasterReceiveByte { {*data {}} } {
    # Command: [0A05]
    # Response: [00][Byte: Data]

    if {[set rc [my Write [binary format H4 0A05] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cu data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method i2cMasterBeginWrite { address } {
    # Command: [0A06][Byte: Address]
    # Response: [00]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    set rc [my Write [binary format H4c 0A06 $address]]
    return $rc
  }

  method i2cMasterBeginRead { address } {
    # Command: [0A07][Byte: Address]
    # Response: [00]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    set rc [my Write [binary format H4c 0A07 $address]]
    return $rc
  }

  method i2cMasterSetAck { setOn } {
    # Command: [0A08][Byte: SetOn]
    # Response: [00]

    if {![::elatec::Check setOn ubyte]} {
      return -500
    }
    set rc [my Write [binary format H4c 0A08 $setOn]]
    return $rc
  }

  # --- --- --- API MIFARECLASSIC --- --- ---

  method mifareClassic_Login { key keyType sector } {
    # Command: [0B00][Byte Array(6): Key][Byte: KeyType][Byte: Sector]
    # Response: [00][Bool: Result]

    switch -nocase -- $key {
      NXP_Transport_KeyAB - FF { set key [binary decode hex FFFFFFFFFFFF] }
      Infineon_Transport_KeyA  { set key [binary decode hex A0A1A2A3A4A5] }
      Infineon_Transport_KeyB  { set key [binary decode hex B0B1B2B3B4B5] }
      NDEF_Formatted_Tags      { set key [binary decode hex D3F7D3F7D3F7] }
    }
    if {[string length $key] != 6} {
      return -500
    }
    switch -nocase -- $keyType {
      A { set keyType 0 }
      B { set keyType 1 }
    }
    if {![::elatec::Check keyType ubyte]} {
      return -501
    }
    if {![::elatec::Check sector ubyte]} {
      return -502
    }
    if {[set rc [my Write [binary format H4a6cc 0B00 $key $keyType $sector] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method mifareClassic_ReadBlock { block {*data {}} } {
    # Command: [0B01][Byte: Block]
    # Response: [00][Bool: Result][Byte Array(16): Data]

    if {![::elatec::Check block ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0B01 $block] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
	upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method mifareClassic_WriteBlock { block data } {
    # Command: [0B02][Byte: Block][Byte Array(16): Data]
    # Response: [00][Bool: Result]

    if {![::elatec::Check block ubyte]} {
      return -500
    }
    if {[set len [string length $data]] > 16} {
      return -501
    }
    if {$len < 16} {
      append data [string repeat \0 [expr {16 - $len}]]
    }
    if {[set rc [my Write [binary format H4ca16 0B02 $block $data] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method mifareClassic_ReadValueBlock { block {*value {}} } {
    # Command: [0B03][Byte: Block]
    # Response: [00][Bool: Result][UInt32: Value]

    if {![::elatec::Check block ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0B03 $block] rdata]] == 0} {
      if {[string trim ${*value}] != {}} {
        upvar ${*value} value
      }
      if {[catch {binary scan $rdata cuiu value} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method mifareClassic_WriteValueBlock { block value } {
    # Command: [0B04][Byte: Block][UInt32: Value]
    # Response: [00][Bool: Result]

    if {![::elatec::Check block ubyte]} {
      return -500
    }
    if {![::elatec::Check value uint32]} {
      return -501
    }
    set rc [my Write [binary format H4ci 0B04 $block $value]]
    return $rc
  }

  method mifareClassic_IncrementValueBlock { block value } {
    # Command: [0B05][Byte: Block][UInt32: Value]
    # Response: [00][Bool: Result]

    if {![::elatec::Check block ubyte]} {
      return -500
    }
    if {![::elatec::Check value uint32]} {
      return -501
    }
    set rc [my Write [binary format H4ci 0B05 $block $value]]
    return $rc
  }

  method mifareClassic_DecrementValueBlock { block value } {
    # Command: [0B06][Byte: Block][UInt32: Value]
    # Response: [00][Bool: Result]

    if {![::elatec::Check block ubyte]} {
      return -500
    }
    if {![::elatec::Check value uint32]} {
      return -501
    }
    set rc [my Write [binary format H4ci 0B06 $block $value]]
    return $rc
  }

  method mifareClassic_CopyValueBlock { sourceBlock destBlock } {
    # Command: [0B07][Byte: SourceBlock][Byte: DestBlock]
    # Response: [00][Bool: Result]

    if {![::elatec::Check sourceBlock ubyte]} {
      return -500
    }
    if {![::elatec::Check destBlock ubyte]} {
      return -501
    }
    set rc [my Write [binary format H4cc 0B07 $sourceBlock $destBlock]]
    return $rc
  }

  # --- --- --- API MIFAREULTRALIGHT --- --- ---

  method mifareUltralight_ReadPage { page {*data {}} } {
    # Command: [0C00][Byte: Page]
    # Response: [00][Bool: Result][Byte Array(16): Data]

    if {![::elatec::Check page ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0C00 $page] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method mifareUltralight_WritePage { page data } {
    # Command: [0C01][Byte: Page][Byte Array(4): Data]
    # Response: [00][Bool: Result]

    if {![::elatec::Check page ubyte]} {
      return -500
    }
    if {![::elatec::Check data LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 0C01 $page $data] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method mifareUltralightC_Authenticate { key } {
    # Command: [0C02][Byte Array(16): Key]
    # Response: [00][Bool: Result]

    if {![::elatec::Check key LENGTH]} {
      return -500
    }
    if {[set rc [my Write [binary format H4a* 0C02 $key] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API ISO15693 --- --- ---

  method iso15693_GenericCommand { flags command data bufferSize {*data {}} } {
    # Command: [0D00][Byte: Flags][Byte: Command][Byte Array(Var): Data][Byte: BufferSize]
    # Response: [00][Bool: Result][Byte Array(Var): Data]

    if {![::elatec::Check flags ubyte]} {
      return -500
    }
    if {![::elatec::Check command ubyte]} {
      return -501
    }
    if {![::elatec::Check data ubyte]} {
      return -502
    }
    if {![::elatec::Check bufferSize ubyte]} {
      return -503
    }
    if {[set rc [my Write [binary format H4ccca*c 0D00 $flags $command [string length data] $data $bufferSize] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cucua* result @dataLen data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso15693_GetSystemInformation { {*systemInfo {}} } {
    # Command: [0D01]
    # Response: [00][Bool: Result][Byte Array(15): SystemInfo]

    if {[set rc [my Write [binary format H4 0D01] rdata]] == 0} {
      if {[string trim ${*systemInfo}] != {}} {
        upvar ${*systemInfo} systemInfo
      }
      if {[catch {binary scan $rdata cua* result systemInfo} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso15693_GetSystemInformationExt { {*systemInfo {}} } {
    # Command: [0D02]
    # Response: [00][Bool: Result][Byte Array(15): SystemInfo]

    if {[set rc [my Write [binary format H4 0D02] rdata]] == 0} {
      if {[string trim ${*systemInfo}] != {}} {
        upvar ${*systemInfo} systemInfo
      }
      if {[catch {binary scan $rdata cua* result systemInfo} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso15693_GetTagTypeFromUID { uID {*tagType {}} } {
    # Command: [0D03][Byte Array(8): UID]
    # Response: [00][Byte: TagType]

    #if {![::elatec::Check uID LENGTH]} {
    #  return -500
    #}
    if {[set rc [my Write [binary format H4a* 0D03 $uID] rdata]] == 0} {
      if {[string trim ${*tagType}] != {}} {
        upvar ${*tagType} tagType
      }
      if {[catch {binary scan $rdata cu tagType} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso15693_GetTagTypeFromSystemInfo { systemInfo {*tagType {}} } {
    # Command: [0D04][Byte Array(15): SystemInfo]
    # Response: [00][Byte: TagType]

    if {![::elatec::Check systemInfo LENGTH]} {
      return -500
    }
    if {[set rc [my Write [binary format H4a* 0D04 $systemInfo] rdata]] == 0} {
      if {[string trim ${*tagType}] != {}} {
        upvar ${*tagType} tagType
      }
      if {[catch {binary scan $rdata cu tagType} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso15693_ReadSingleBlock { blockNumber bufferSize {*blockData {}} } {
    # Command: [0D05][UInt16: BlockNumber][Byte: BufferSize]
    # Response: [00][Bool: Result][Byte Array(Var): BlockData]

    if {![::elatec::Check blockNumber uint16]} {
      return -500
    }
    if {![::elatec::Check bufferSize ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4sc 0D05 $blockNumber $bufferSize] rdata]] == 0} {
      if {[string trim ${*blockData}] != {}} {
        upvar ${*blockData} blockData
      }
      if {[catch {binary scan $rdata cucua* result @blockDataLen blockData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso15693_ReadSingleBlockExt { blockNumber bufferSize {*blockData {}} } {
    # Command: [0D06][UInt16: BlockNumber][Byte: BufferSize]
    # Response: [00][Bool: Result][Byte Array(Var): BlockData]

    if {![::elatec::Check blockNumber uint16]} {
      return -500
    }
    if {![::elatec::Check bufferSize ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4sc 0D06 $blockNumber $bufferSize] rdata]] == 0} {
      if {[string trim ${*blockData}] != {}} {
        upvar ${*blockData} blockData
      }
      if {[catch {binary scan $rdata cucua* result @blockDataLen blockData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso15693_WriteSingleBlock { blockNumber blockData } {
    # Command: [0D07][UInt16: BlockNumber][Byte Array(Var): BlockData]
    # Response: [00][Bool: Result]

    if {![::elatec::Check blockNumber uint16]} {
      return -500
    }
    if {![::elatec::Check blockData ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4sca* 0D07 $blockNumber [string length blockData] $blockData] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso15693_WriteSingleBlockExt { blockNumber blockData } {
    # Command: [0D08][UInt16: BlockNumber][Byte Array(Var): BlockData]
    # Response: [00][Bool: Result]

    if {![::elatec::Check blockNumber uint16]} {
      return -500
    }
    if {![::elatec::Check blockData ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4sca* 0D08 $blockNumber [string length blockData] $blockData] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API CRYPTO --- --- ---

  method crypto_Init { cryptoEnv cryptoMode key } {
    # Command: [0E00][Byte: CryptoEnv][Byte: CryptoMode][Byte Array(Var): Key]
    # Response: [00]

    if {![::elatec::Check cryptoEnv ubyte]} {
      return -500
    }
    if {![::elatec::Check cryptoMode ubyte]} {
      return -501
    }
    if {![::elatec::Check key ubyte]} {
      return -502
    }
    set rc [my Write [binary format H4ccca* 0E00 $cryptoEnv $cryptoMode [string length key] $key]]
    return $rc
  }

  method encrypt { cryptoEnv plainBlock {*cipheredBlock {}} } {
    # Command: [0E01][Byte: CryptoEnv][Byte Array(Var): PlainBlock]
    # Response: [00][Byte Array(Var): CipheredBlock]

    if {![::elatec::Check cryptoEnv ubyte]} {
      return -500
    }
    if {![::elatec::Check plainBlock ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cca* 0E01 $cryptoEnv [string length plainBlock] $plainBlock] rdata]] == 0} {
      if {[string trim ${*cipheredBlock}] != {}} {
        upvar ${*cipheredBlock} cipheredBlock
      }
      if {[catch {binary scan $rdata cua* @cipheredBlockLen cipheredBlock} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method decrypt { cryptoEnv cipheredBlock {*plainBlock {}} } {
    # Command: [0E02][Byte: CryptoEnv][Byte Array(Var): CipheredBlock]
    # Response: [00][Byte Array(Var): PlainBlock]

    if {![::elatec::Check cryptoEnv ubyte]} {
      return -500
    }
    if {![::elatec::Check cipheredBlock ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cca* 0E02 $cryptoEnv [string length cipheredBlock] $cipheredBlock] rdata]] == 0} {
      if {[string trim ${*plainBlock}] != {}} {
        upvar ${*plainBlock} plainBlock
      }
      if {[catch {binary scan $rdata cua* @plainBlockLen plainBlock} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method cbc_ResetInitVector { cryptoEnv } {
    # Command: [0E03][Byte: CryptoEnv]
    # Response: [00]

    if {![::elatec::Check cryptoEnv ubyte]} {
      return -500
    }
    set rc [my Write [binary format H4c 0E03 $cryptoEnv]]
    return $rc
  }

  # --- --- --- API DESFIRE --- --- ---

  method desfire_GetApplicationIDs { cryptoEnv {*appIDList {}} {maxAppIDCnt 28} } {
    # Command: [0F00][Byte: CryptoEnv][Byte: MaxAIDCnt]
    # Response: [00][Bool: Result][variable number of UInt32: AIDs]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check maxAppIDCnt ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0F00 $cryptoEnv $maxAppIDCnt] rdata]] == 0} {
      if {[string trim ${*appIDList}] != {}} {
        upvar ${*appIDList} appIDList
      }
      if {[catch {binary scan $rdata cucuiu* result ppIDListLen appIDList} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_CreateApplication { cryptoEnv appID changeKeyAccessRights confChangeable freeCreateDelete freeDirList allowChangeMasterKey numOfKeys keyType } {
    # Command: [0F01][Byte: CryptoEnv][UInt32: AID]
    #   [Byte: [4 Bit: ChangeKeyAccessRights][1 Bit: ConfigurationChangeable][1 Bit: FreeCreateDelete][1 Bit: FreeDirectoryList][1 Bit: AllowChangeMasterKey]][UInt32: NumberOfKeys][UInt32: KeyType]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check appID uint32]} {
      return -501
    }
    if {![::elatec::Check changeKeyAccessRights 4bit]} {
      return -502
    }
    if {![::elatec::CheckDESFireKeySettings keySettings changeKeyAccessRights confChangeable freeCreateDelete freeDirList allowChangeMasterKey]} {
      return -503
    }
    if {![::elatec::Check numOfKeys uint32]} {
      return -504
    }
    if {![::elatec::Check keyType DESF_KEYTYPE]} {
      return -505
    }
    if {[set rc [my Write [binary format H4cicii 0F01 $cryptoEnv $appID $keySettings $numOfKeys $keyType] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_DeleteApplication { cryptoEnv appID } {
    # Command: [0F02][Byte: CryptoEnv][UInt32: AID]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check appID uint32]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ci 0F02 $cryptoEnv $appID] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_SelectApplication { cryptoEnv appID } {
    # Command: [0F03][Byte: CryptoEnv][UInt32: AID]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check appID uint32]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ci 0F03 $cryptoEnv $appID] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_Authenticate { cryptoEnv keyNo key keyType authMode } {
    # Command: [0F04][Byte: CryptoEnv][Byte: KeyNoTag][Byte Array(Var): Key][Byte: KeyType][Byte: Mode]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check keyNo ubyte]} {
      return -501
    }
    if {![::elatec::Check key DESF_KEYLEN]} {
      return -502
    }
    if {![::elatec::Check keyType DESF_KEYTYPE]} {
      return -503
    }
    if {![::elatec::Check authMode DESF_AUTHMODE]} {
      return -504
    }
    if {[set rc [my Write [binary format H4ccca*cc 0F04 $cryptoEnv $keyNo [string length $key] $key $keyType $authMode] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_GetKeySettings { cryptoEnv {*keySettings {}} {*keyType {}} } {
    # Command: [0F05][Byte: CryptoEnv]
    # Response: [00][Bool: Result][Byte: KeySettings][UInt32: NumberOfKeys][UInt32: KeyType]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0F05 $cryptoEnv] rdata]] == 0} {
      if {[string trim ${*keySettings}] != {}} {
	upvar ${*keySettings} keySettings
      }
      if {[string trim ${*numberOfKeys}] != {}} {
	upvar ${*numberOfKeys} numberOfKeys
      }
      if {[string trim ${*keyType}] != {}} {
	upvar ${*keyType} keyType
      }
      if {[catch {binary scan $rdata cucuiuiu result keySettings numberOfKeys keyType} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_GetFileIDs { cryptoEnv {*fileIdList {}} {maxFileIDCnt 32} } {
    # Command: [0F06][Byte: CryptoEnv][Byte: MaxFileIDCount]
    # Response: [00][Bool: Result][variable number of Bytes: FileIDList]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check maxFileIDCnt ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0F06 $cryptoEnv $maxFileIDCnt] rdata]] == 0} {
      if {[string trim ${*fileIdList}] != {}} {
        upvar ${*fileIdList} fileIdList
      }
      if {[catch {binary scan $rdata cucucu* result fileIdListLen fileIdList} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_GetFileSettings { cryptoEnv fileNo {*fileSettings {}} } {
    # Command: [0F07][Byte: CryptoEnv][Byte: FileNo]
    # Response: [00][Bool: Result][Byte Array(20): FileSettings]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0F07 $cryptoEnv $fileNo] rdata]] == 0} {
      if {[string trim ${*fileSettings}] != {}} {
	upvar ${*fileSettings} fileSettings
      }
      if {[catch {binary scan $rdata cua* result fileSettings} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_ReadData { cryptoEnv fileNo offset length commSet {*data {}} } {
    # Command: [0F08][Byte: CryptoEnv][Byte: FileNo][UInt16: Offset][Byte: Length][Byte: CommSet]
    # Response: [00][Bool: Result][Byte Array(Var): Data]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check offset uint16]} {
      return -502
    }
    if {![::elatec::Check length ubyte]} {
      return -503
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -504
    }
    if {[set rc [my Write [binary format H4ccscc 0F08 $cryptoEnv $fileNo $offset $length $commSet] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cucua* result dataLen data} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_WriteData { cryptoEnv fileNo offset data commSet } {
    # Command: [0F09][Byte: CryptoEnv][Byte: FileNo][UInt16: Offset][Byte Array(Var): Data][Byte: CommSet]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check offset uint16]} {
      return -502
    }
    if {[string length $data] > 255} {
      return -503
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -504
    }
    if {[set rc [my Write [binary format H4ccsca*c 0F09 $cryptoEnv $fileNo $offset [string length $data] $data $commSet] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_GetValue { cryptoEnv fileNo commSet {*value {}} } {
    # Command: [0F0A][Byte: CryptoEnv][Byte: FileNo][Byte: CommSet]
    # Response: [00][Bool: Result][UInt32: Value]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ccc 0F0A $cryptoEnv $fileNo $commSet] rdata]] == 0} {
      if {[string trim ${*value}] != {}} {
        upvar ${*value} value
      }
      if {[catch {binary scan $rdata cuiu result value} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_Credit { cryptoEnv fileNo value commSet } {
    # Command: [0F0B][Byte: CryptoEnv][Byte: FileNo][UInt32: Value][Byte: CommSet]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check value uint32]} {
      return -502
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -503
    }
    if {[set rc [my Write [binary format H4ccic 0F0B $cryptoEnv $fileNo $value $commSet] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_Debit { cryptoEnv fileNo value commSet } {
    # Command: [0F0C][Byte: CryptoEnv][Byte: FileNo][UInt32: Value][Byte: CommSet]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check value uint32]} {
      return -502
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -503
    }
    if {[set rc [my Write [binary format H4ccic 0F0C $cryptoEnv $fileNo $value $commSet] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_LimitedCredit { cryptoEnv fileNo value commSet } {
    # Command: [0F0D][Byte: CryptoEnv][Byte: FileNo][UInt32: Value][Byte: CommSet]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check value uint32]} {
      return -502
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -503
    }
    if {[set rc [my Write [binary format H4ccic 0F0D $cryptoEnv $fileNo $value $commSet] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_FreeMem { cryptoEnv {*freeMemory {}} } {
    # Command: [0F0E][Byte: CryptoEnv]
    # Response: [00][Bool: Result][UInt16: FreeMemory]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0F0E $cryptoEnv] rdata]] == 0} {
      if {[string trim ${*freeMemory}] != {}} {
        upvar ${*freeMemory} freeMemory
      }
      if {[catch {binary scan $rdata cusu* result freeMemory} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_FormatTag { cryptoEnv } {
    # Command: [0F0F][Byte: CryptoEnv]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0F0F $cryptoEnv] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }


  method desfire_CreateDataFile { cryptoEnv fileNo fileType commSet accessRights fileSize } {
    # Command: [0F10][Byte: CryptoEnv][Byte: FileNo][Byte: FileType][Byte: CommSet][UInt16: AccessRights][UInt32: FileSize][:]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check fileType DESF_FILETYPE]} {
      return -502
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -503
    }
    if {![::elatec::Check accessRights uint16]} {
      return -504
    }
    if {![::elatec::Check fileSize uint32]} {
      return -505
    }
    set reserved [string repeat \0 12]
    if {[set rc [my Write [binary format H4ccccsia* 0F10 $cryptoEnv $fileNo $fileType $commSet $accessRights $fileSize $reserved] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_CreateValueFile { cryptoEnv fileNo fileType commSet accessRights lowerLimit upperLimit limitedCreditValue limitedCreditEnabled } {
    # Command: [0F11][Byte: CryptoEnv][Byte: FileNo][Byte: FileType][Byte: CommSet][UInt16: AccessRights]
    #   [UInt32: LowerLimit][UInt32: UpperLimit][UInt32: LimitedCreditValue][Bool: LimitedCreditEnabled]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check fileType DESF_FILETYPE]} {
      return -502
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -503
    }
    if {![::elatec::Check accessRights uint16]} {
      return -504
    }
    if {![::elatec::Check lowerLimit uint32]} {
      return -505
    }
    if {![::elatec::Check upperLimit uint32]} {
      return -506
    }
    if {![::elatec::Check limitedCreditValue uint32]} {
      return -507
    }
    if {![::elatec::Check limitedCreditEnabled ubyte]} {
      return -508
    }
    set reserved [string repeat \0 3]
    if {[set rc [my Write [binary format H4ccccsiiica* 0F11 $cryptoEnv $fileNo $fileType $commSet $accessRights $lowerLimit $upperLimit $limitedCreditValue $limitedCreditEnabled $reserved] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_GetVersion { cryptoEnv {*version {}} } {
    # Command: [0F12][Byte: CryptoEnv]
    # Response: [00][Bool: Result][Byte Array(34): Version]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0F12 $cryptoEnv] rdata]] == 0} {
      if {[string trim ${*version}] != {}} {
	upvar ${*version} version
      }
      if {[catch {binary scan $rdata cua* result version} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_DeleteFile { cryptoEnv fileNo } {
    # Command: [0F13][Byte: CryptoEnv][Byte: FileNo]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0F13 $cryptoEnv $fileNo] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_CommitTransaction { cryptoEnv } {
    # Command: [0F14][Byte: CryptoEnv]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0F14 $cryptoEnv] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_AbortTransaction { cryptoEnv } {
    # Command: [0F15][Byte: CryptoEnv]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0F15 $cryptoEnv] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_GetUID { cryptoEnv {*uid {}} {bufferSize 255} } {
    # Command: [0F16][Byte: CryptoEnv][Byte: BufferSize]
    # Response: [00][Bool: Result][Byte Array(Var): UID]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check bufferSize ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0F16 $cryptoEnv $bufferSize] rdata]] == 0} {
      if {[string trim ${*uid}] != {}} {
	upvar ${*uid} uid
      }
      if {[catch {binary scan $rdata cucua* result uidLen uid} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_GetKeyVersion { cryptoEnv keyNo {*keyVersion {}} } {
    # Command: [0F17][Byte: CryptoEnv][Byte: KeyNo]
    # Response: [00][Bool: Result][Byte Array(1): KeyVersion]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check keyNo ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0F17 $cryptoEnv $keyNo] rdata]] == 0} {
      if {[string trim ${*keyVersion}] != {}} {
	upvar ${*keyVersion} keyVersion
      }
      if {[catch {binary scan $rdata cucua* result keyVersion} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_ChangeKeySettings { cryptoEnv changeKeyAccessRights confChangeable freeCreateDelete freeDirList allowChangeMasterKey numOfKeys keyType } {
    # Command: [0F18][Byte: CryptoEnv]
    #   [Byte: [4 Bit: ChangeKeyAccessRights][1 Bit: ConfigurationChangeable][1 Bit: FreeCreateDelete][1 Bit: FreeDirectoryList][1 Bit: AllowChangeMasterKey]][UInt32: NumberOfKeys][UInt32: KeyType]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::CheckDESFireKeySettings keySettings changeKeyAccessRights confChangeable freeCreateDelete freeDirList allowChangeMasterKey]} {
      return -501
    }
    if {![::elatec::Check numOfKeys uint32]} {
      return -502
    }
    if {![::elatec::Check keyType DESF_KEYTYPE]} {
      return -503
    }
    if {[set rc [my Write [binary format H4ccii 0F18 $cryptoEnv $keySettings $numOfKeys $keyType] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_ChangeKey { cryptoEnv keyNo oldKey newKey keyVersion changeKeyAccessRights confChangeable freeCreateDelete freeDirList allowChangeMasterKey numOfKeys keyType } {
    # Command: [0F19][Byte: CryptoEnv][Byte: KeyNo][Byte Array(Var): OldKey][Byte Array(Var): NewKey][Byte: KeyVersion]
    #   [Byte: [4 Bit: ChangeKeyAccessRights][1 Bit: ConfigurationChangeable][1 Bit: FreeCreateDelete][1 Bit: FreeDirectoryList][1 Bit: AllowChangeMasterKey]][UInt32: NumberOfKeys][UInt32: KeyType]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check keyNo ubyte]} {
      return -501
    }
    if {![::elatec::Check oldKey DESF_KEYLEN]} {
      return -502
    }
    if {![::elatec::Check newKey DESF_KEYLEN]} {
      return -503
    }
    if {![::elatec::Check keyVersion ubyte]} {
      return -504
    }
    if {![::elatec::Check changeKeyAccessRights 4bit]} {
      return -505
    }
    if {![::elatec::CheckDESFireKeySettings keySettings changeKeyAccessRights confChangeable freeCreateDelete freeDirList allowChangeMasterKey]} {
      return -506
    }
    if {![::elatec::Check numOfKeys uint32]} {
      return -507
    }
    if {![::elatec::Check keyType DESF_KEYTYPE]} {
      return -508
    }
    if {[set rc [my Write [binary format H4ccca* 0F19 $cryptoEnv $keyNo [string length $oldKey] $oldKey][binary format ca*ccii [string length $newKey] $newKey $keyVersion $keySettings $numOfKeys $keyType] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_ChangeFileSettings { cryptoEnv fileNo newCommSet oldAccessRights newAccessRights } {
    # Command: [0F1A][Byte: CryptoEnv][Byte: FileNo][Byte: NewCommSet][UInt16: OldAccessRights][UInt16: NewAccessRights]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check newCommSet DESF_COMMSET]} {
      return -502
    }
    if {![::elatec::Check oldAccessRights uint16]} {
      return -503
    }
    if {![::elatec::Check newAccessRights uint16]} {
      return -504
    }
    if {[set rc [my Write [binary format H4cccss 0F1A $cryptoEnv $fileNo $newCommSet $oldAccessRights $newAccessRights] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_DisableFormatTag { cryptoEnv } {
    # Command: [0F1B][Byte: CryptoEnv]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0F1B $cryptoEnv] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_EnableRandomID { cryptoEnv } {
    # Command: [0F1C][Byte: CryptoEnv]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 0F1C $cryptoEnv] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_SetDefaultKey { cryptoEnv key keyVersion } {
    # Command: [0F1D][Byte: CryptoEnv][Byte Array(Var): Key][Byte: KeyVersion]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check key DESF_KEYLEN]} {
      return -501
    }
    if {![::elatec::Check keyVersion ubyte]} {
      return -502
    }
    if {[set rc [my Write [binary format H4cca*c 0F1D $cryptoEnv [string length $key] $key $keyVersion] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return -9
  }

  method desfire_SetATS { ats } {
    # Command: [0F1E][Byte: CryptoEnv][Byte Array(Var): ATS]
    # Response: [00][Bool: Result]

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {[set rc [my Write [binary format H4cca* 0F1E $cryptoEnv [string length $ats] $ats] rdata]] == 0} {
      if {[catch {binary scan $rdata cu* result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return -9
  }

  method desfire_CreateRecordFile { cryptoEnv fileNo fileType commSet accessRights recordSize maxNumbersOfRecords } {
    # CHECK DESCRIPTION

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check fileType DESF_FILETYPE]} {
      return -502
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -503
    }
    if {![::elatec::Check accessRights uint16]} {
      return -504
    }
    if {![::elatec::Check recordSize uint32]} {
      return -505
    }
    if {![::elatec::Check maxNumbersOfRecords uint32]} {
      return -506
    }
    if {[set rc [my Write [binary format H4ccccsiiH16 0F1F $cryptoEnv $fileNo $fileType $commSet $accessRights $recordSize $maxNumbersOfRecords 0000000000000000] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_ReadRecords { cryptoEnv fileNo offset numberOfRecods recordSize commSet {*data {}} } {
    # CHECK DESCRIPTION

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check offset uint16]} {
      return -502
    }
    if {![::elatec::Check numberOfRecods uint32]} {
      return -503
    }
    if {![::elatec::Check recordSize uint16]} {
      return -504
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -505
    }
    if {[set rc [my Write [binary format H4ccsisc 0F20 $cryptoEnv $fileNo $offset $numberOfRecods $recordSize $commSet] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cucua* result @dataLen data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_WriteRecord { cryptoEnv fileNo offset data commSet } {
    # CHECK DESCRIPTION

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {![::elatec::Check offset uint16]} {
      return -502
    }
    if {![::elatec::Check data ubyte]} {
      return -503
    }
    if {![::elatec::Check commSet DESF_COMMSET]} {
      return -504
    }
    if {[set rc [my Write [binary format H4ccsca*c 0F21 $cryptoEnv $fileNo $offset [string length data] $data $commSet] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method desfire_ClearRecordFile { cryptoEnv fileNo } {
    # CHECK DESCRIPTION

    if {![::elatec::Check cryptoEnv CRYPTO_ENV]} {
      return -500
    }
    if {![::elatec::Check fileNo ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 0F22 $cryptoEnv $fileNo] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }


  # --- --- --- API ISO7816 --- --- ---

  method iso7816_GetSlotStatus { channel {*slotStatus {}} } {
    # Command: [1000][Byte: Channel]
    # Response: [00][Bool: Result][Byte Array(3): SlotStatus]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1000 $channel] rdata]] == 0} {
      if {[string trim ${*slotStatus}] != {}} {
        upvar ${*slotStatus} slotStatus
      }
      if {[catch {binary scan $rdata cua* result slotStatus} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso7816_IccPowerOn { channel maxATRByteCnt bPowerSelect {*aTR {}} {*bStatus {}} {*bError {}} } {
    # Command: [1001][Byte: Channel][Byte: MaxATRByteCnt][Byte: bPowerSelect]
    # Response: [00][Bool: Result][Byte Array(Var): ATR][Byte: bStatus][Byte: bError]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check maxATRByteCnt ubyte]} {
      return -501
    }
    if {![::elatec::Check bPowerSelect ubyte]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ccc 1001 $channel $maxATRByteCnt $bPowerSelect] rdata]] == 0} {
      if {[string trim ${*aTR}] != {}} {
        upvar ${*aTR} aTR
      }
      if {[string trim ${*bStatus}] != {}} {
        upvar ${*bStatus} bStatus
      }
      if {[string trim ${*bError}] != {}} {
        upvar ${*bError} bError
      }
      if {[catch {binary scan $rdata cucua*cucu result @aTRLen aTR bStatus bError} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso7816_IccPowerOff { channel {*slotStatus {}} } {
    # Command: [1002][Byte: Channel]
    # Response: [00][Bool: Result][Byte Array(3): SlotStatus]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1002 $channel] rdata]] == 0} {
      if {[string trim ${*slotStatus}] != {}} {
        upvar ${*slotStatus} slotStatus
      }
      if {[catch {binary scan $rdata cua* result slotStatus} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso7816_SetCommSettings { channel commSettings } {
    # Command: [1003][Byte: Channel][Byte Array(13): CommSettings]
    # Response: [00][Bool: Result]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check commSettings LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 1003 $channel $commSettings] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso7816_Transceive { channel tx maxRXByteCnt {*rx {}} } {
    # Command: [1004][Byte: Channel][Byte Array(Var): TX][Byte: MaxRXByteCnt]
    # Response: [00][Bool: Result][Byte Array(Var): RX]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check tx ubyte]} {
      return -501
    }
    if {![::elatec::Check maxRXByteCnt ubyte]} {
      return -502
    }
    if {[set rc [my Write [binary format H4cca*c 1004 $channel [string length tx] $tx $maxRXByteCnt] rdata]] == 0} {
      if {[string trim ${*rx}] != {}} {
        upvar ${*rx} rx
      }
      if {[catch {binary scan $rdata cucua* result @rxLen rx} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso7816_ExchangeAPDU { channel header txData maxRXByteCnt {*rxData {}} {*statusWord {}} } {
    # Command: [1005][Byte: Channel][Byte Array(9): Header][Byte Array(Var): TXData][UInt16: MaxRXByteCnt]
    # Response: [00][Bool: Result][Byte Array(Var): RXData][UInt16: StatusWord]

    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check header LENGTH]} {
      return -501
    }
    if {![::elatec::Check txData ubyte]} {
      return -502
    }
    if {![::elatec::Check maxRXByteCnt uint16]} {
      return -503
    }
    if {[set rc [my Write [binary format H4ca*ca*s 1005 $channel $header [string length txData] $txData $maxRXByteCnt] rdata]] == 0} {
      if {[string trim ${*rxData}] != {}} {
        upvar ${*rxData} rxData
      }
      if {[string trim ${*statusWord}] != {}} {
        upvar ${*statusWord} statusWord
      }
      if {[catch {binary scan $rdata cucua*su result @rxDataLen rxData statusWord} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API ICLASS --- --- ---

  method iCLASS_GetPACBits { maxPACBytes {*pACBitCnt {}} {*pAC {}} } {
    # Command: [1100][Byte: MaxPACBytes]
    # Response: [00][Bool: Result][Byte: PACBitCnt][Byte Array(Var): PAC]

    if {![::elatec::Check maxPACBytes ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1100 $maxPACBytes] rdata]] == 0} {
      if {[string trim ${*pACBitCnt}] != {}} {
        upvar ${*pACBitCnt} pACBitCnt
      }
      if {[string trim ${*pAC}] != {}} {
        upvar ${*pAC} pAC
      }
      if {[catch {binary scan $rdata cucucua* result pACBitCnt @pACLen pAC} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API ISO14443 --- --- ---

  method iso14443a_GetATS { maxATSByteCnt {*ats {}} } {
    # Command: [1200][Byte: MaxATSByteCnt]
    # Response: [00][Bool: Result][Byte Array(Var): ATS]

    if {![::elatec::Check maxATSByteCnt ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1200 $maxATSByteCnt] rdata]] == 0} {
      if {[string trim ${*ats}] != {}} {
        upvar ${*ats} ats
      }
      if {[catch {binary scan $rdata cucua* result @atsLen ats} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso14443b_GetATQB { maxATQBByteCnt {*atqb {}} } {
    # Command: [1201][Byte: MaxATQBByteCnt]
    # Response: [00][Bool: Result][Byte Array(Var): ATQB]

    if {![::elatec::Check maxATQBByteCnt ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1201 $maxATQBByteCnt] rdata]] == 0} {
      if {[string trim ${*atqb}] != {}} {
        upvar ${*atqb} atqb
      }
      if {[catch {binary scan $rdata cucua* result @atqbLen atqb} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }


  method iso14443_4_CheckPresence {} {
    # Command: [1202]
    # Response: [00][Bool: Result]

    if {[set rc [my Write [binary format H4 1202] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso14443_4_TDX { tx maxRXByteCnt {*rx {}} } {
    # Command: [1203][Byte Array(Var): TX][Byte: MaxRXByteCnt]
    # Response: [00][Bool: Result][Byte Array(Var): RX]

    if {![::elatec::Check tx ubyte]} {
      return -500
    }
    if {![::elatec::Check maxRXByteCnt ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca*c 1203 [string length tx] $tx $maxRXByteCnt] rdata]] == 0} {
      if {[string trim ${*rx}] != {}} {
        upvar ${*rx} rx
      }
      if {[catch {binary scan $rdata cucua* result @rxLen rx} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso14443A_GetATQA { {*atqa {}} } {
    # Command: [1204]
    # Response: [00][Bool: Result][Byte Array(2): ATQA]

    if {[set rc [my Write [binary format H4 1204] rdata]] == 0} {
      if {[string trim ${*atqa}] != {}} {
        upvar ${*atqa} atqa
      }
      if {[catch {binary scan $rdata cua* result atqa} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso14443A_GetSAK { {*sak {}} } {
    # Command: [1206][Byte: MaxAnswerToATTRIBByteCnt]
    # Response: [00][Bool: Result][Byte Array(Var): AnswerToATTRIB]

    if {[set rc [my Write [binary format H4 1205] rdata]] == 0} {
      if {[string trim ${*sak}] != {}} {
        upvar ${*sak} sak
      }
      if {[catch {binary scan $rdata cucu result sak} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso14443_3_TDX { tx maxRXByteCnt timeout {*rx {}} } {
    # Command: [1207][Byte Array(Var): TX][Byte: MaxRXByteCnt][UInt16: Timeout]
    # Response: [00][Bool: Result][Byte Array(Var): RX]

    if {![::elatec::Check tx ubyte]} {
      return -500
    }
    if {![::elatec::Check maxRXByteCnt ubyte]} {
      return -501
    }
    if {![::elatec::Check timeout UInt16:]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ca*cs 1207 [string length tx] $tx $maxRXByteCnt $timeout] rdata]] == 0} {
      if {[string trim ${*rx}] != {}} {
        upvar ${*rx} rx
      }
      if {[catch {binary scan $rdata cucua* result @rxLen rx} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method iso14443a_SearchMultiTag { {*uidList {}} {maxUIDListByteCnt 255} } {
    # Command: [1208][Byte: MaxUIDListByteCnt]
    # Response: [00][Bool: Result][Byte: UIDCnt][variable number of Bytes: UIDList]

    if {![::elatec::Check maxUIDListByteCnt ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1208 $maxUIDListByteCnt] rdata]] == 0} {
      if {[string trim ${*uidList}] != {}} {
        upvar ${*uidList} uidList
      }
      if {[catch {binary scan $rdata cucucua* result listCnt listLen list} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
      set uidList {}
      if {[string is integer -strict $listCnt] && $listCnt > 0} {
	for {set n 0} {$n < $listCnt} {incr n} {
	  if {[binary scan $list cua* uidLen data]} {
	    lappend uidList [string range $list 1 $uidLen]
	    set list [string range $list [expr {$uidLen + 1}] end]
	  }
	}
      }
    }
    return $rc
  }

  method iso14443a_SelectTag { uid } {
    # Command: [1209][Byte Array(Var): UID]
    # Response: [00][Bool: Result]

    if {[set rc [my Write [binary format H4ca* 1209 [string length $uid] $uid] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
	return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API AT55 --- --- ---

  method at55_Begin {} {
    # Command: [1500]
    # Response: [00]

    set rc [my Write [binary format H4 1500]]
    return $rc
  }

  method at55_ReadBlock { address {*data {}} } {
    # Command: [1501][Byte: Address]
    # Response: [00][Bool: Result][Byte Array(4): Data]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1501 $address] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method at55_ReadBlockProtected { address password {*data {}} } {
    # Command: [1502][Byte: Address][Byte Array(4): Password]
    # Response: [00][Bool: Result][Byte Array(4): Data]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check password LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 1502 $address $password] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cua* result data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method at55_WriteBlock { address data } {
    # Command: [1503][Byte: Address][Byte Array(4): Data]
    # Response: [00][Bool: Result]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check data LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 1503 $address $data] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method at55_WriteBlockProtected { address data password } {
    # Command: [1504][Byte: Address][Byte Array(4): Data][Byte Array(4): Password]
    # Response: [00][Bool: Result]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check data LENGTH]} {
      return -501
    }
    if {![::elatec::Check password LENGTH]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ca*a* 1504 $address $data $password] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method at55_WriteBlockAndLock { address data } {
    # Command: [1505][Byte: Address][Byte Array(4): Data]
    # Response: [00][Bool: Result]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check data LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 1505 $address $data] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method at55_WriteBlockProtectedAndLock { address data password } {
    # Command: [1506][Byte: Address][Byte Array(4): Data][Byte Array(4): Password]
    # Response: [00][Bool: Result]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check data LENGTH]} {
      return -501
    }
    if {![::elatec::Check password LENGTH]} {
      return -502
    }
    if {[set rc [my Write [binary format H4ca*a* 1506 $address $data $password] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API NFCSNEP --- --- ---

  method senp_Init {} {
    # Command: [1800]
    # Response: [00][Bool: Result]

    if {[set rc [my Write [binary format H4 1800] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method senp_GetConnectionState { {*connectionState {}} } {
    # Command: [1801]
    # Response: [00][Byte: ConnectionState]

    if {[set rc [my Write [binary format H4 1801] rdata]] == 0} {
      if {[string trim ${*connectionState}] != {}} {
        upvar ${*connectionState} connectionState
      }
      if {[catch {binary scan $rdata cu connectionState} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method senp_GetFragmentByteCount { direction {*byteCount {}} } {
    # Command: [1802][Byte: Direction]
    # Response: [00][UInt16: ByteCount]

    if {![::elatec::Check direction ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1802 $direction] rdata]] == 0} {
      if {[string trim ${*byteCount}] != {}} {
        upvar ${*byteCount} byteCount
      }
      if {[catch {binary scan $rdata su byteCount} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method senp_BeginMessage { msgByteCnt } {
    # Command: [1803][UInt32: MsgByteCnt]
    # Response: [00][Bool: Result]

    if {![::elatec::Check msgByteCnt uint32]} {
      return -500
    }
    if {[set rc [my Write [binary format H4i 1803 $msgByteCnt] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method senp_SendMessageFragment { msgFrag } {
    # Command: [1804][Byte Array(Var): MsgFrag]
    # Response: [00][Bool: Result]

    if {![::elatec::Check msgFrag ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4ca* 1804 [string length msgFrag] $msgFrag] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method senp_TestMessage { {*msgByteCnt {}} } {
    # Command: [1805]
    # Response: [00][Bool: Result][UInt32: MsgByteCnt]

    if {[set rc [my Write [binary format H4 1805] rdata]] == 0} {
      if {[string trim ${*msgByteCnt}] != {}} {
        upvar ${*msgByteCnt} msgByteCnt
      }
      if {[catch {binary scan $rdata cuiu result msgByteCnt} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method senp_ReceiveMessageFragment { fragByteCnt {*msgFrag {}} } {
    # Command: [1806][UInt16: FragByteCnt]
    # Response: [00][Bool: Result][Byte Array(Var): MsgFrag]

    if {![::elatec::Check fragByteCnt uint16]} {
      return -500
    }
    if {[set rc [my Write [binary format H4s 1806 $fragByteCnt] rdata]] == 0} {
      if {[string trim ${*msgFrag}] != {}} {
        upvar ${*msgFrag} msgFrag
      }
      if {[catch {binary scan $rdata cucua* result @msgFragLen msgFrag} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API EM4150 --- --- ---

  method eM4150_Login { password } {
    # Command: [1900][Byte Array(4): Password]
    # Response: [00][Bool: Result]

    if {![::elatec::Check password LENGTH]} {
      return -500
    }
    if {[set rc [my Write [binary format H4a* 1900 $password] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method eM4150_ReadWord { address {*word {}} } {
    # Command: [1901][Byte: Address]
    # Response: [00][Bool: Result][Byte Array(4): Word]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1901 $address] rdata]] == 0} {
      if {[string trim ${*word}] != {}} {
        upvar ${*word} word
      }
      if {[catch {binary scan $rdata cua* result word} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method eM4150_WriteWord { address word } {
    # Command: [1902][Byte: Address][Byte Array(4): Word]
    # Response: [00][Bool: Result]

    if {![::elatec::Check address ubyte]} {
      return -500
    }
    if {![::elatec::Check word LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ca* 1902 $address $word] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method eM4150_WritePassword { actualPassword newPassword } {
    # Command: [1903][Byte Array(4): ActualPassword][Byte Array(4): NewPassword]
    # Response: [00][Bool: Result]

    if {![::elatec::Check actualPassword LENGTH]} {
      return -500
    }
    if {![::elatec::Check newPassword LENGTH]} {
      return -501
    }
    if {[set rc [my Write [binary format H4a*a* 1903 $actualPassword $newPassword] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API FILESYS --- --- ---

  method fSMount { storageID mode } {
    # Command: [1A00][Byte: StorageID][UInt32: Mode]
    # Response: [00][Bool: Result]

    if {![::elatec::Check storageID ubyte]} {
      return -500
    }
    if {![::elatec::Check mode uint32]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ci 1A00 $storageID $mode] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSFormat { storageID magicValue } {
    # Command: [1A01][Byte: StorageID][UInt32: MagicValue]
    # Response: [00][Bool: Result]

    if {![::elatec::Check storageID ubyte]} {
      return -500
    }
    if {![::elatec::Check magicValue uint32]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ci 1A01 $storageID $magicValue] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSOpen { fileEnv storageID fileID mode } {
    # Command: [1A02][Byte: FileEnv][Byte: StorageID][UInt32: FileID][Byte: Mode]
    # Response: [00][Bool: Result]

    if {![::elatec::Check fileEnv ubyte]} {
      return -500
    }
    if {![::elatec::Check storageID ubyte]} {
      return -501
    }
    if {![::elatec::Check fileID uint32]} {
      return -502
    }
    if {![::elatec::Check mode ubyte]} {
      return -503
    }
    if {[set rc [my Write [binary format H4ccic 1A02 $fileEnv $storageID $fileID $mode] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSClose { fileEnv } {
    # Command: [1A03][Byte: FileEnv]
    # Response: [00][Bool: Result]

    if {![::elatec::Check fileEnv ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1A03 $fileEnv] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSCloseAll {} {
    # Command: [1A04]
    # Response: [00]

    set rc [my Write [binary format H4 1A04]]
    return $rc
  }

  method fSSeek { fileEnv origin pos } {
    # Command: [1A05][Byte: FileEnv][Byte: Origin][UInt32: Pos]
    # Response: [00][Bool: Result]

    if {![::elatec::Check fileEnv ubyte]} {
      return -500
    }
    if {![::elatec::Check origin ubyte]} {
      return -501
    }
    if {![::elatec::Check pos uint32]} {
      return -502
    }
    if {[set rc [my Write [binary format H4cci 1A05 $fileEnv $origin $pos] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSTell { fileEnv origin {*pos {}} } {
    # Command: [1A06][Byte: FileEnv][Byte: Origin]
    # Response: [00][Bool: Result][UInt32: Pos]

    if {![::elatec::Check fileEnv ubyte]} {
      return -500
    }
    if {![::elatec::Check origin ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cc 1A06 $fileEnv $origin] rdata]] == 0} {
      if {[string trim ${*pos}] != {}} {
        upvar ${*pos} pos
      }
      if {[catch {binary scan $rdata cuiu result pos} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSReadBytes { fileEnv byteCount {*data {}} } {
    # Command: [1A07][Byte: FileEnv][UInt16: ByteCount]
    # Response: [00][Bool: Result][Byte Array(Var): Data]

    if {![::elatec::Check fileEnv ubyte]} {
      return -500
    }
    if {![::elatec::Check byteCount uint16]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cs 1A07 $fileEnv $byteCount] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
        upvar ${*data} data
      }
      if {[catch {binary scan $rdata cucua* result @dataLen data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSWriteBytes { fileEnv data {*bytesWritten {}} } {
    # Command: [1A08][Byte: FileEnv][Byte Array(Var): Data]
    # Response: [00][Bool: Result][UInt16: BytesWritten]

    if {![::elatec::Check fileEnv ubyte]} {
      return -500
    }
    if {![::elatec::Check data ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cca* 1A08 $fileEnv [string length data] $data] rdata]] == 0} {
      if {[string trim ${*bytesWritten}] != {}} {
        upvar ${*bytesWritten} bytesWritten
      }
      if {[catch {binary scan $rdata cusu result bytesWritten} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSFindFirst { storageID {*fileInfo {}} } {
    # Command: [1A09][Byte: StorageID]
    # Response: [00][Bool: Result][Byte Array(8): FileInfo]

    if {![::elatec::Check storageID ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1A09 $storageID] rdata]] == 0} {
      if {[string trim ${*fileInfo}] != {}} {
        upvar ${*fileInfo} fileInfo
      }
      if {[catch {binary scan $rdata cua* result fileInfo} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSFindNext { {*fileInfo {}} } {
    # Command: [1A0A]
    # Response: [00][Bool: Result][Byte Array(8): FileInfo]

    if {[set rc [my Write [binary format H4 1A0A] rdata]] == 0} {
      if {[string trim ${*fileInfo}] != {}} {
        upvar ${*fileInfo} fileInfo
      }
      if {[catch {binary scan $rdata cua* result fileInfo} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSDelete { storageID fileID } {
    # Command: [1A0B][Byte: StorageID][UInt32: FileID]
    # Response: [00][Bool: Result]

    if {![::elatec::Check storageID ubyte]} {
      return -500
    }
    if {![::elatec::Check fileID uint32]} {
      return -501
    }
    if {[set rc [my Write [binary format H4ci 1A0B $storageID $fileID] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSRename { storageID oldFileID newFileID } {
    # Command: [1A0C][Byte: StorageID][UInt32: OldFileID][UInt32: NewFileID]
    # Response: [00][Bool: Result]

    if {![::elatec::Check storageID ubyte]} {
      return -500
    }
    if {![::elatec::Check oldFileID uint32]} {
      return -501
    }
    if {![::elatec::Check newFileID uint32]} {
      return -502
    }
    if {[set rc [my Write [binary format H4cii 1A0C $storageID $oldFileID $newFileID] rdata]] == 0} {

      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  method fSGetStorageInfo { storageID {*storageInfo {}} } {
    # Command: [1A0D][Byte: StorageID]
    # Response: [00][Bool: Result][Byte Array(9): StorageInfo]

    if {![::elatec::Check storageID ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1A0D $storageID] rdata]] == 0} {
      if {[string trim ${*storageInfo}] != {}} {
        upvar ${*storageInfo} storageInfo
      }
      if {[catch {binary scan $rdata cua* result storageInfo} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
        return -1
      }
    }
    return $rc
  }

  # --- --- --- API SLE44xx --- --- ---

  method sle_GetATR { {channel 0x20} {*atr {}} } {
    # Command: [1F00][Byte: Channel]
    # Response: [00][Bool: Result][Byte Array(Var): ATR]

    my variable obj
    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1F00 $channel] rdata]] == 0} {
      if {[string trim ${*atr}] != {}} {
	upvar ${*atr} atr
      }
      if {[catch {binary scan $rdata cua* result atr} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method sle_ReadMainMemory { {channel 0x20} {address 0} {*data {}} {byteCnt 1} } {
    # Command: [1F01][Byte: Channel][UInt32: Address][UInt32: ByteCnt]
    # Response: [00][Bool: Result][Byte Array(Var): Data]

    my variable obj
    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check address uint32]} {
      return -501
    }
    if {![::elatec::Check byteCnt uint32]} {
      return -502
    }
    if {[set rc [my Write [binary format H4css 1F01 $channel $address $byteCnt] rdata]] == 0} {
      if {[string trim ${*data}] != {}} {
	upvar ${*data} data
      }
      if {[catch {binary scan $rdata cusua* result dataLen data} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method sle_UpdateMainMemory { {channel 0x20} {address 0} {value} } {
    # Command: [1F02][Byte: Channel][UInt32: Address][Byte: Value]
    # Response: [00][Bool: Result]

    my variable obj
    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check address uint32]} {
      return -501
    }
    if {[set rc [my Write [binary format H4csa 1F02 $channel $address $value] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method sle_ReadSecurityMemory { {channel 0x20} {*secMemData {}} } {
    # Command: [1F03][Byte: Channel]
    # Response: [00][Bool: Result][Byte Array(Var): SecMemData]

    my variable obj
    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1F03 $channel] rdata]] == 0} {
      if {[string trim ${*secMemData}] != {}} {
	upvar ${*secMemData} secMemData
      }
      if {[catch {binary scan $rdata cua* result secMemData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method sle_UpdateSecurityMemory { {channel 0x20} {address {}} {secMemData {}} } {
    # Command: [1F04][Byte: Channel][Byte: Address][Byte: SecMemData]
    # Response: [00][Bool: Result]

    my variable obj
    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check address ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cca 1F04 $channel $address $secMemData] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method sle_ReadProtectionMemory { {channel 0x20} {*protMemData {}} } {
    # Command: [1F05][Byte: Channel]
    # Response: [00][Bool: Result][Byte Array(Var): ProtMemData]

    my variable obj
    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {[set rc [my Write [binary format H4c 1F05 $channel] rdata]] == 0} {
      if {[string trim ${*protMemData}] != {}} {
	upvar ${*protMemData} protMemData
      }
      if {[catch {binary scan $rdata cua* result protMemData} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method sle_WriteProtectionMemory { {channel 0x20} {address {}} {protMemData {}} } {
    # Command: [1F06][Byte: Channel][Byte: Address][Byte: ProtMemData]
    # Response: [00][Bool: Result]

    my variable obj
    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check address ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cca 1F06 $channel $address $protMemData] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  method sle_CompareVerificationData { {channel 0x20} {address {}} {verificationData {}} } {
    # Command: [1F07][Byte: Channel][Byte: Address][Byte: VerificationData]
    # Response: [00][Bool: Result]

    my variable obj
    if {![::elatec::Check channel ubyte]} {
      return -500
    }
    if {![::elatec::Check address ubyte]} {
      return -501
    }
    if {[set rc [my Write [binary format H4cca 1F07 $channel $address $verificationData] rdata]] == 0} {
      if {[catch {binary scan $rdata cu result} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

  # --- --- --- API USER COMMANDS --- --- ---

  method userGetVersion { {*version {}} } {
    # Command: [FF00]
    # Response: [00][ASCII string: Version]

    my variable obj
    if {[set rc [my Write [binary format H4 FF00] rdata]] == 0} {
      if {[string trim ${*version}] != {}} {
	upvar ${*version} version
      }
      if {[catch {binary scan $rdata A* version} sc]} {
        return -8
      }
      set obj(user,api) $version
    }
    return $rc
  }

  method userSearchLoop { {*found {}} {*tagType {}} {*idBitCount {}} {*id {}} } {
    # Command: [FF01]
    # Response: [00][Bool: Result][Byte: found][Byte: TagType][Byte: IDBitCount][Byte Array(Var): ID]

    my variable obj
    if {[set rc [my Write [binary format H4 FF01] rdata]] == 0} {
      if {[string trim ${*found}] != {}} {
	upvar ${*found} found
      }
      if {[string trim ${*tagType}] != {}} {
	upvar ${*tagType} tagType
      }
      if {[string trim ${*idBitCount}] != {}} {
	upvar ${*idBitCount} idBitCount
      }
      if {[string trim ${*id}] != {}} {
	upvar ${*id} id
      }
      if {[catch {binary scan $rdata cucucucucua* result tagType idBitCount idLen id} sc]} {
        return -8
      }
      if {$sc && [string is integer -strict $result] && $result != 1} {
	return -1
      }
    }
    return $rc
  }

}

# -----------------------------------------------------------------------------

package provide elatec [elatec::RcsId revision]

# -----------------------------------------------------------------------------
